; --------------------------------------------------------------------------
; Prenos podatkov med videopomnilnikom in PC in obratno             V - S10
;
; Program je s strani avtorja dan v javno last dne 22.05.1999.
; Avtor put this program to public domain 22.05.1999.
;
; Program je dovoljeno distribuirati v vseh oblikah, prepovedano
; pa je njegovo koriscenje v komercialne namene, prav tako pa je
; tudi prepovedano  spreminjanje programske kode ali komentarjev
; v programu.
;
; Vse pripombe o delovanju,napakah,ali pa ideje za nove funkcije
; so dobrodosle !
;
; Avtor:  Darko Volk, S57UUD
; Post:   Kacice 15, 6215 Divaca, Slovenija
; E-mail: darko.volk@siol.net
; HAM:    @S50BOX.SVN.EU
; Tel:    +386 67 632-765
; ---------------------------------------------------------------------------
NAME    ADPCC        ; ZA 98S53  - ANALOGNO DIGITALNA CONVERZIJA -> PC
MDATA   SEGMENT DATA
BDATA   SEGMENT BIT
MCODE   SEGMENT CODE
PSTART  EQU     0000H             ; Program counter start
STACK 	EQU     50H               ; Startna vrednost za stack ( stack ++ )
; ----------- Banka 0 ---------
RV0     EQU 00                    ; Register equates
RV1     EQU 01                    ;
RV2     EQU 02                    ;
RV3     EQU 03                    ;
RV4     EQU 04                    ;
RV5     EQU 05                    ;
RV6     EQU 06                    ;
RV7     EQU 07                    ;

        RSEG MDATA                ;
SRB:    DS 40                     ; RS232 BUFFER
IB:     DS 1                      ; INDEX BUFFERJA
INCAD:  DS 1                      ; INCREMENT SPOMINA(50 za realni cas)
        RSEG BDATA                ;                  ( 1 za detaljni prenos)
BF:     DBIT 1                    ; BUFFER JE POLN
; --------------------------------------------------------------------------
; PREKINITVENE RUTINE
; --------------------------------------------------------------------------
        RSEG MCODE                ;
        ORG PSTART+0              ;
        LJMP START                ; +00H=reset jump
        ORG PSTART+03H            ; +03H=IE0
        RETI                      ;
        ORG PSTART+0BH            ; +0BH=TF0 ... timer 0
        RETI                      ;
        ORG PSTART+13H            ; +13H=IE1
        RETI                      ;
        ORG PSTART+1BH            ; +1BH=TF1 ... timer 1
        RETI                      ;
        ORG PSTART+23H            ; +23H= RI+TI.... serial interupt ...
        JB  RI,BY_RX              ; Poklici rutino za sprejem
        RETI                      ;
        ORG PSTART+2BH            ; +2H= TF2+EXF2
        RETI                      ;
        ORG PSTART+43H            ; IADC
	RETI                      ;
	ORG PSTART+4BH            ; IEX2
        RETI                      ;
	ORG PSTART+53H            ; IEX3
        RETI                      ;
        ORG PSTART+5BH            ; IEX4
        RETI                      ;
        ORG PSTART+63H            ; IEX5
        RETI                      ;
        ORG PSTART+6BH            ; IEX6
        RETI                      ;

; --------------------------------------------------------------------------
; RS232 RUTINE
; --------------------------------------------------------------------------
; RX RS232 Rutina
; --------------------------------------------------------------------------
BY_RX:  PUSH ACC                  ; Shrani ACC
        PUSH RV0                  ; Shrani R0
        MOV A,SBUF                ; Premakni iz SBUF v A
        JNB TI,$                  ; Pocakaj da se prejsnji znak izpise
        CLR TI                    ; Obrisi TI
        MOV SBUF,A                ; Premakni iz A v SBUF (Echo) !!
        PUSH ACC                  ; Shrani znak
        MOV A,IB                  ; Premakni vsebino IB v A
        MOV R0,#SRB               ; V R0 daj naslov bufferja
        ADD A,R0                  ; Poisci pozicijo
        MOV R0,A                  ; premakni v R0
        POP ACC                   ; Vrni znak
        MOV @R0,A                 ; Zapisi znak v buffer
        CJNE A,#13 BY_RX1         ; Ce ni enter skoci na BY_RX1
        CLR A                     ; Obrisi A
        MOV @R0,A                 ; Napravi 0 term. string
        SETB BF                   ; Buffer je poln !
        MOV IB,#0FFH              ; Index buff n zacetek
BY_RX2: JNB TI,BY_RX2             ; Drugace cakaj da odda znak  !!
        CLR TI                    ; Obrisi TI
        MOV SBUF,#10              ; Poslji ga v novo vrstico    !!
BY_RX1: INC IB                    ; Povecaj index bufferja
        POP RV0                   ; Vrni R0
        POP ACC                   ; Vrni ACC
        CLR RI                    ; Znak je sprejet
        RETI                      ;

; --------------------------------------------------------------------------
; TX RS232 Rutina
; --------------------------------------------------------------------------
OUTCH:  JB P,OUTC1                ; Glede na parity setiraj
        CLR TB8                   ; TB8, ki se kot deveti bit
        SJMP OUTC2                ; poslje po RS232
OUTC1:  SETB TB8                  ;
OUTC2:  JNB TI,$                  ; Pocakaj da je znak poslan
        CLR TI                    ; Obrisi TI
        MOV SBUF,A                ; output the char
        RET                       ; To je vse

; --------------------------------------------------------------------------
; Inicializacija RS232 porta
; --------------------------------------------------------------------------
INIT232:MOV SCON,#11010000B       ; Rezim 3: 9bit UART
        MOV A,PCON                ; Nastavi hitrost rs232 porta
        SETB ACC.7                ; na
        MOV PCON,A                ; 57600 !
        MOV TL1,#0FFH             ;
        MOV TH1,#0FFH             ; se drugi del
        MOV TMOD,#20H             ; Autoreload timer 1
        SETB TCON.6               ; Omogoci delovanje T1
        SETB IE.4                 ; Vkljuci int. za RS232
        SETB IE.7                 ; Vkljuci interapte
        RET                       ;

; --------------------------------------------------------------------------
; Rutina izpise text ki je za to rutino vse do char(0) !
; --------------------------------------------------------------------------
PRTNEXT:POP DPH	                  ; pointer v DPTR, ta pa je novi program counter,
        POP DPL                   ; ki je na stacku
PRTN1:  CLR A                     ;
        MOVC A,@A+DPTR            ; vzami character
        INC DPTR                  ;
        CJNE A,#0,PRTN3           ; ce je 0 se vrni
        JMP @A+DPTR               ; skoci na PC za 0+1
PRTN3:  ACALL OUTCH               ;
        AJMP PRTN1                ;
; --------------------------------------------------------------------------
; POZOR TU JE KONEC RUTINE !!  ******************
; --------------------------------------------------------------------------

; --------------------------------------------------------------------------
; Zakasnitev za R7 ms
; --------------------------------------------------------------------------
DELAYR7:LCALL   DEL1MS            ;
	DJNZ    R7,DELAYR7        ; R7 x poklici zakasnitev 1 ms.
	RET                       ;

;-------------------------------------------------------------------------
; Delay 1ms za quartz 11.0952 MHz
;-------------------------------------------------------------------------
DEL1MS: PUSH ACC                  ;
        PUSH B                    ;
        PUSH RV7                  ;
	MOV R7,#150               ; 150 x podeli 1 z 1
        MOV A,#01H                ;
        MOV B,#01H                ;
DEL1M1:	DIV AB                    ; pa si zapravil 1 ms !
	DJNZ R7,DEL1M1            ;
        POP RV7                   ;
        POP B                     ;
        POP ACC                   ;
	RET                       ;

;-------------------------------------------------------------------------
; Oznacitev konca graficnega moda
;-------------------------------------------------------------------------
SEL_E:  ACALL PRTNEXT             ;
DB 'End',0                        ; Vrni string End - konec graficnega moda.
        RET                       ;

;-------------------------------------------------------------------------
; Signal se na osciloskop izpisuje iz spomina
;-------------------------------------------------------------------------
SEL_Q:  ACALL PRTNEXT             ;
DB 'q izvrsen - OK',13,10,0       ;
        SETB P3.3                 ; MV rezim delovanaja
        RET                       ; Konec vpisovanja v spomn

;-------------------------------------------------------------------------
; Signal se v realnem casu vpisuje v spomin in istocasno na osciloskop
;-------------------------------------------------------------------------
SEL_W:  ACALL PRTNEXT             ;
DB 'w izvrsen - OK',13,10,0       ;
        SETB P3.3                 ; MV rezim delovanaj
        CLR P3.3                  ; Vpis v spomin !
        RET                       ;

;-------------------------------------------------------------------------
; Prenos podatkov iz izbranega spomina na PC po RS232
;-------------------------------------------------------------------------
SELE:   INC R0                    ;
        MOV A,@R0                 ;
        MOV R4,A                  ;
        ACALL PRTNEXT             ; Izpisi text
DB 'Vrstica',0                    ; To je startni string, ki prozi rutino
        SETB P3.3                 ; MV rezim delovanaj
        CLR P3.3                  ; Vpis v spomin !        'w' ukaz
        MOV R7,#30                ; 30ms zakasnitve
        ACALL DELAYR7             ;
        CLR P3.5                  ; NORM signal je 0       'O' ukaz
        MOV R3,P2                 ; Shrani PORT 2 - Ne sme pokvariti
        PUSH RV3                  ; Izbiro memorije
        MOV A,P2                  ; Obrisi P2 , razen izbire spomina
        ANL A,#10000000B          ;
        MOV P2,A                  ; od tu dalje se posilja slika
        MOV P0,#0                 ; Obrisi P0
        SETB P3.6                 ; Citaj spomin  ( Na pisati vanj !)
SELE1:  CLR P3.7                  ; Daj podatke na izhod
        MOV R7,#06FH              ; Potrebna konstantna zakasnitev
        DJNZ R7,$                 ; za uspesen prenos
        MOV P1,#0FFH              ; Nastavi + na vhod za citanje preko P1
        MOV A,P1                  ; Precitaj podatek
        SETB P3.7                 ; Ugasni OE na spominu
        ACALL OUTCH               ; Poslji znak na RS232
        MOV A,P0                  ; Povecaj naslov na P0
        ADD A,INCAD               ; Povecuj po 50
        MOV P0,A                  ;
        JNC SELE1                 ; Ce prekoraci povecaj se P2
        MOV A,P2                  ;
        SETB ACC.7                ; pozor ! koda ugotovi, kdaj je
        ADD A,#1                  ; napolnjena 1/4 celotnega
        JB P2.7,SELE2             ; spomina. oziroma odcita 15 bitni
        CLR ACC.7                 ; adresni prostor
SELE2:  MOV P2,A                  ;
        JNC SELE1                 ;
        SETB P3.5                 ; NORM signal je 1
        POP RV3                   ; Vrni se P2 ( ohranitev izbranega spomina )
        MOV P2,R3                 ;
        ACALL PRTNEXT             ; Izpisi se sinhronizacijsko sekvenco
DB 'Rep',0                        ;
        RET                       ;
                                  ;
;-------------------------------------------------------------------------
; Izbira enega od stirih spominov
;-------------------------------------------------------------------------
SELM:   MOV A,SRB+2               ; Izbira enega od segmentov spomina
        CJNE A,#'1',SELM1         ; Ce ni 1 je kaj drugega
        CLR P3.4                  ; P3.4 izbere enega od obeh spominov
        CLR P2.7                  ; P2.7 izbere spodnji/zgornji del
        ACALL PRTNEXT             ;
DB 'Spomin 1 ',13,10,0            ;
        RET                       ;
SELM1:  CJNE A,#'2',SELM2         ; Ce ni 2 je kaj drugega
        SETB P3.4                 ;
        CLR P2.7                  ;
        ACALL PRTNEXT             ;
DB 'Spomin 2 ',13,10,0            ;
        RET                       ;
SELM2:  CJNE A,#'3',SELM3         ; Ce ni 3 je kaj drugega
        CLR P3.4                  ;
        SETB P2.7                 ;
        ACALL PRTNEXT             ;
DB 'Spomin 3 ',13,10,0            ;
        RET                       ;
SELM3:  CJNE A,#'4',SELM4         ; Ce ni 4 je nekaj narobe
        SETB P3.4                 ;
        SETB P2.7                 ;
        ACALL PRTNEXT             ;
DB 'Spomin 4 ',13,10,0            ;
        RET                       ;
SELM4:  ACALL PRTNEXT             ;
DB 'Napaka v izbiri memorije',13,10,0
        RET                       ;

;-------------------------------------------------------------------------
; Hardware kontrola S53MV nacin delovanja
;-------------------------------------------------------------------------
SELN:   ACALL PRTNEXT             ;
DB 'Norm je 1 - OK',13,10,0       ;
        SETB P3.5                 ; NORM signal je 1
        RET                       ;

;-------------------------------------------------------------------------
; Software kontrola - celotno AD-DA vezje se nadzira z mikroprocesorjem
;-------------------------------------------------------------------------
SELO:   ACALL PRTNEXT             ;
DB 'Norm je 0 - OK',13,10,0       ;
        CLR P3.5                  ; NORM signal je 0
        RET                       ;

;-------------------------------------------------------------------------
; Doloci se increment adresiranja spomina pri prenosu na PC
;-------------------------------------------------------------------------
SELW:   MOV A,SRB+2               ; shrani increment adrese
        MOV INCAD,A               ;
        ACALL PRTNEXT             ;
DB 'Prenos E',0                   ; Identifikacija stringa
        RET                       ;
; -------------------------------------------------------------------
; prenos 24 by iz paralelnega vhoda na 74HC245 na PC RS232          -
; rutina prenasa rezultate meritev 89C2051 na PC RS232              -
; struktura je sledeca:                                             -
;  offset dolzina vsebina                                           -
;    0         4  frekvenca VCO1                                    -
;    4         4  frekvenca VCO2                                    -
;    8         4  frekvenca VCO EXT 1 (s preskalerjem -4.5Ghz max)  -
;   12         4  frekvenca VCO EXT 2 (brez preskalerja 50 Mhz nax) -
;   16         4  obmocje - spodnja meja                            -
;   20         4  obmocje - zgornja meja                            -
; -------------------------------------------------------------------
SWP1:   ACALL PRTNEXT             ;
DB 'Rez',0                        ;
        SETB  P3.2                ; Set P3.2 na 1 - pritisnjena tipka 0 !
        MOV   R7,#50              ; Pocakaj 50 ms
        ACALL DELAYR7             ;
        CLR   P3.2                ; Spusti tipko
        MOV   R5,P3               ; Shrani P3 v R5 do konca prenosa
        SETB  P3.5                ; Postavi NORM
        SETB  P3.6                ; Postavi MWRI - /E !!
        SETB  P3.7                ; Pripravi za CITAJ !!
                                  ; Sinhronizacija na FF in 00 h !!
SWP12:  MOV   P0,#0FFH            ; Cakaj dokler ne sprejmes
        NOP                       ; Malo pocakaj
        MOV   A,P0                ;
        CJNE  A,#0FFH,SWP12       ; FFH na P0
SWP13:  MOV   P0,#0FFH            ; Cakaj dokler ne sprejmes
        NOP                       ; Malo pocakaj
        MOV   A,P0                ;
        CJNE  A,#00H,SWP13        ; 00H na P0
        MOV   R7,#10              ; Cakaj 10 ms
        ACALL DELAYR7             ; Od tu dalje je asinhroni paralelni
                                  ; prenos 24 znakov !
        MOV   R6,#48              ; Prenasamo 24 by
SWP11:  MOV   R7,#3               ; Cakaj 5 ms
        ACALL DELAYR7             ;
        MOV   P0,#0FFH            ; Postavi FFH na izhod
        MOV   A,P0                ; Precitaj znak
        CALL  OUTCH               ; in ga izpisi
        DJNZ  R6,SWP11            ; Prenesi vseh 24 by
        MOV   P3,R5               ; Vrni prejsnjo vrednost v P3
        ACALL PRTNEXT             ;
DB ' Preklop OK',13,10,0          ;
        RET                       ;

;-------------------------------------------------------------------------
; Start programa
;-------------------------------------------------------------------------
START:  MOV SP,#STACK             ; Nastavi SP
        CLR P3.2                  ; Ugasni stikalo
        ACALL INIT232             ; Init RS232
        SETB TI                   ; Priprava za pisanje
        CLR RI                    ; in citanje
        ACALL PRTNEXT             ; Izpis pozdravne vrstice
DB 10,13,10,10,10,10,10,10,10,10,10,10,10,10,10,0
        ACALL PRTNEXT             ; Izpis pozdravne vrstice
DB 'Darko Volk S57UUD - AD prenos s spektralnega analizatorja na PC',13,10,0
        ACALL PRTNEXT             ;
DB 'Maj 1999',10,'   V-S9',13,10,10,10,10,10,10,10,10,0   ;
        CLR BF                    ; RS232 buffer je izpraznjen !
        MOV IB,#0                 ; Index buffer na 0
MAIN:   ACALL PRTNEXT             ;
DB 'S57UUD>',0                    ; Prompt znak
MAINX:  JNB BF MAINX              ; Ce ni stringa se vrti v zanki
        MOV R0,#SRB               ;
        MOV A,@R0                 ;
        CLR BF                    ; RS232 buffer je izpraznjen
        MOV P1,0FFH               ;
        CJNE A,#'M',MAI01         ;
        ACALL SELM                ; Izbira enega od stirih spominov
        SJMP MAIN                 ;
MAI01:  CJNE A,#'R',MAI02         ; ***R komanda
        AJMP  START               ; Reset sistema ( ponovni zagon )
MAI02:  CJNE A,#'W',MAI03         ; ***W komanda
        ACALL SELW                ; Definira increment spomina pri
        AJMP MAIN                 ; odcitkih za prenos na PC !
MAI03:  CJNE A,#'S',MAI04         ; ***S komanda
        ACALL SWP1                ; Precita vse rezultate iz merine enote
        AJMP MAIN                 ; (2051) in jih poslje na PC !
MAI04:  CJNE A,#'N',MAI05         ; ***N komanda
        ACALL SELN                ; N rezim delovanja ( MV compatibilem )
        AJMP MAIN                 ;
MAI05:  CJNE A,#'O',MAI06         ; ***O komanda
        ACALL SELO                ; O rezim delovanja - procesor nadzira
        AJMP MAIN                 ; vse bistvene signale do pomnilnika !
MAI06:  CJNE A,#'w',MAI07         ; ***w komanda
        ACALL SEL_W               ; stalen vpis iz AD v spomin N in
        AJMP MAIN                 ; istocasna interpretacija preko DA
MAI07:  CJNE A,#'e',MAI08         ; ***e komanda
        ACALL SEL_E               ; vrne string za konec prenosa v
        AJMP MAIN                 ; realnem casu.
MAI08:  CJNE A,#'q',MAI09         ; ***q komanda
        ACALL SEL_Q               ; interpretacija iz spomina N preko
        AJMP MAIN                 ; DA pretvornika
MAI09:  CJNE A,#'E',MAI10         ; ***E komanda
        ACALL SELE                ;
        AJMP MAIN                 ;
MAI10:  ACALL PRTNEXT             ;
DB 'Napacen ukaz !',13,10,0       ;
        AJMP MAIN                 ;

        END
