********** program FSPAN *************

; --------------------------------------------------------------------------
; FSPAN - Frekvencmeter SPektralnega ANalizatorja                   V - F21
;
; Program je s strani avtorja dan v javno last dne 22.05.1999.
; Avtor put this program to public domain 22.05.1999.
;
; Program je dovoljeno distribuirati v vseh oblikah, prepovedano
; pa je njegovo koriscenje v komercialne namene, prav tako pa je
; tudi prepovedano  spreminjanje programske kode ali komentarjev
; v programu.
;
; Vse pripombe o delovanju,napakah,ali pa ideje za nove funkcije
; so dobrodosle !
;
; Avtor:  Darko Volk, S57UUD
; Post:   Kacice 15, 6215 Divaca, Slovenija
; E-mail: darko.volk@siol.net
; HAM:    @S50BOX.SVN.EU
; Tel:    ++386 67 632-765
; --------------------------------------------------------------------------
NAME    FSPAN        ; ZA AT2051 - MERITEV FREKVENCE
;                      SPEKTRALNEGA ANALIZATORJA
; --------------------------------------------------------------------------
; Program je sicer dokaj dobro dokumentiran, vendar je razumevanje
; nemogoce brez hkratnega pregledovanja elektricnega nacrta vezja.
;
; --------------------------------------------------------------------------
;   Program vsebuje: -Init kodo
;                    -Priziganje LED diode
;                    -Krmiljenje LCD displeja
;                    -Odcitovanje frekvence v stirih tockah
;                    -Izpis frekvence decimalno na LCD.
;                    -Prenos infomacij o meritvah na drug procesor
;                    -Odcitovanje tipk na celni plosci
M32DATA SEGMENT DATA
M32CODE SEGMENT CODE
; --------------------------------------------------------------------------
; Data komande za LCD display
; --------------------------------------------------------------------------
LCDDADR EQU     10000000B         ; LCD set data adress
LCDINT  EQU     00110000B         ; LCD init koda
LCD5X7  EQU     00111000B         ; LCD 5 X 7  karakter, 2 vrstici
LCD5X10 EQU     00110100B         ; LCD 5 X 10 karakter, 1 vrstica
LCDINCC EQU     00000110B         ; LCD increment cursor
LCDON   EQU     00001100B         ; LCD displ, cursor in blink ON
LCDCLR  EQU     00000001B         ; LCD clear display
LCDHOME EQU     00000010B         ; LCD cursor home
; --------------------------------------------------------------------------
; Statusi vpisani v 74HC137
; --------------------------------------------------------------------------
;             /GL A   CB
MASK137 EQU     01011100B         ; Maska za krmiljenje 137
OE590   EQU     00000100B         ; 74HC590  Output Enable
RC590   EQU     00000110B         ; 74HC590  RCLK
OL590   EQU     00000101B         ; 74HC590  Output Latch
SLED    EQU     00000111B         ; Prizgi led ( ugasni ostalo )
CL590   EQU     00100100B         ; 74HC590  Clear
ENLCD   EQU     00100101B         ; Enable LCD
NC137A  EQU     00100110B         ; Ni v uporabi   Q5
CTIPKE  EQU     00100111B         ; Citanje tipk
; --------------------------------------------------------------------------
; Podatki !
; --------------------------------------------------------------------------
        RSEG    M32DATA
U374 :  DS 1                      ; Vsebina 74HC374
POU1 :  DS 1                      ; Pravilen status vpisov v P1
POU3 :  DS 1                      ; Pravilen status vpisov v P3
NRIN :  DS 1                      ; Stevilo meritev
RE:     DS 3                      ; Rezultat
RE1:    DS 3                      ; Rezultat 1
RE2:    DS 3                      ; Rezultat 2
RE3:    DS 3                      ; Rezultat 3
RE4:    DS 3                      ; Rezultat 4
MERI:   DS 1                      ; 1-Zahteva za meritev,0-Konec meritve
NRMR:   DS 1                      ; Stevolo meritev
NRCA:   DS 1                      ; Cas meritve
ZANK:   DS 1                      ; Stevilo zank
POT:    DS 1                      ; Potenciometer
SET16:  DS 2                      ; Vhodni za - 16 bit aritmetiko
SET32:  DS 4                      ; Vhodni za - 32 bit aritmetiko
MUL16:  DS 2                      ; Mnozitelj za 16 bit mnozenje
DIV16:  DS 2                      ; Delitelj za 16 bit mnozenje
ADD16:  DS 2                      ; Sestevanec za 16 bit sestevanje
SUB16:  DS 2                      ; Odstevanec za 16 bit odstevanje
ADD32:  DS 4                      ; Sestevanec za 32 bit sestevanje
SUB32:  DS 4                      ; Odstevanec za 32 bit odstevanje
INDATA: DS 2                      ; Vhodni podatki -> decimalni zapis
DI:     DS 2                      ; Delovno polje pri BIN2DEC rutini
OP_0:   DS 1                      ; Izhodna polja za 32 bitne operacije
OP_1:   DS 1                      ;
OP_2:   DS 1                      ;
OP_3:   DS 1                      ;
DVCO1:  DS 4                      ; Rezultat vco 1
DVCO2:  DS 4                      ; Rezultat vco 2
DVCX1:  DS 4                      ; Rezultat vco externi 1
DVCX2:  DS 4                      ; Rezultat vco externi 2
DMELE:  DS 4                      ; Rezultat leva meja
DMEDE:  DS 4                      ; Rezultat desna meja
TMP_0:  DS 1                      ; 32 bitna delovna polja
TMP_1:  DS 1                      ;
TMP_2:  DS 1                      ;
TMP_3:  DS 1                      ;
DSP_1:  DS 1                      ; Izhod iz BIN2DEC rutine
DSP_2:  DS 1                      ; je v dolzini petih znakov.
DSP_3:  DS 1                      ;
DSP_4:  DS 1                      ;
DSP_5:  DS 1                      ;
; --------------------------------------------------------------------------
; Program uporablja interupte !!! zato se rutine lahko zacno
; na adresi 0030h !
; --------------------------------------------------------------------------
        RSEG    M32CODE           ;
        ORG     0000H             ;
        AJMP    START             ; Reset
        ORG     0003H             ;
        SJMP    EXIN              ; external interupt 0
        ORG     000BH             ;
        RETI                      ; internal-timer 0
        ORG     0013H             ;
        RETI                      ; external interupt 1
        ORG     001BH             ;
        RETI                      ; internal-timer 1
        ORG     0023H             ;
        RETI                      ; Serial port
        ORG     002BH             ;
        RETI                      ; internal timer 2 ( ni v 2051 !)
        ORG     0030H
; --------------------------------------------------------------------------
; Interupt rutina.
; --------------------------------------------------------------------------
EXIN:   PUSH    7                 ; Shranimo registre na SP
        PUSH    6                 ; da rutina sama nebi zmotila
        PUSH    5                 ; delovanja glavnega programa
        PUSH    4                 ;
        PUSH    3                 ;
        PUSH    2                 ;
        PUSH    1                 ;
        PUSH    0                 ; R0
        PUSH    0F0H              ; B
        PUSH    0E0H              ; A
        PUSH    0D0H              ; Shrani PSW
        MOV     R2,MERI           ;
        CJNE    R2,#0 EXIN4       ; Glavni program zahteva meritve
        SJMP    EXIN5             ; Ce je MERI 0 preskoci meritev
EXIN4:  MOV     R4,NRIN           ; Primerjaj stevilo meritev
        DEC     R4                ;
        MOV     NRIN,R4           ;
        CJNE    R4,#0 EXIN1       ; Meritev se ni koncana
        MOV R5,#OL590             ; premakni iz stevca na izhod..
        ACALL   SET137            ;
        MOV     P1,#0FFH          ; pripravi port za citanje...
        MOV     R5,#OE590         ; prikljuci izhod iz 590 !
        ACALL   SET137            ;
        MOV     RE+2,P1           ; premakni port
        MOV     RE+1,TL0          ; Premakni se stevec
        MOV     RE,TH0            ;
EXIN5:  MOV     R5,#SLED          ; prizgi led (deselekt 74HC590!)
        ACALL   SET137            ;
        MOV     TL0,#0            ; reset stevca
        MOV     TH0,#0            ;
        MOV     R5,#CL590         ; Obrisi tudi stevec 74HC590 !
        ACALL   SET137            ;
        MOV     R5,#SLED          ; prizgi led (deselekt 74HC590!)
        ACALL   SET137            ;
        MOV     MERI,#0           ; Meritev je koncana
EXIN1:  POP     0D0H              ; Vrni PSW
        POP     0E0H              ; A
        POP     0F0H              ; B
        POP     0                 ; Vrni se vse ostale registre
        POP     1                 ;
        POP     2                 ;
        POP     3                 ;
        POP     4                 ;
        POP     5                 ;
        POP     6                 ;
        POP     7                 ;
        RETI                      ; Koncaj prekinitveno rutino.

; --------------------------------------------------------------------------
; U374
; BIT  0 1 - Krmiljenje LCD displeya.
; --------------------------------------------------------------------------
; BIT     2 3 - Izbira merilnega vhoda
; --------------------------------------------------------------------------
;         0 0    preskaler za VCO 2
;         0 1    vhod brez preskalerja
;         1 0    preskaler za zunanji signal
;         1 1    preskaler za VCO 1
; --------------------------------------------------------------------------
; BIT         4 5 6 7 - Izbira komparatorskega vhoda
; --------------------------------------------------------------------------
;             0   0 0 - neizkorisceno
;             0   0 1 - Levo
;             0   1 0 - neizkorisceno
;             0   1 1 - Desno
;             1   0 0 - neizkorisceno
;             1   0 1 - neizkorisceno
;             1   1 0 - neizkorisceno
;             1   1 1 - potenciometer  1
; --------------------------------------------------------------------------
; BIT          5  - Izbira casa meritve
; --------------------------------------------------------------------------
;              0  - cas meritve podaljsan na 2 krat.
;              1  - normalno
; --------------------------------------------------------------------------
; Inicializacija programa
; --------------------------------------------------------------------------
START:  MOV     SP,#65H           ; POZOR !! PAZI NA SP !
        ACALL   LCDINIT           ; LCD se spravi k zivljenju
        MOV     POU3,#11110111B   ; Init POU3
        MOV     P3,POU3           ; Premakni na P3
        MOV     TL0,#0            ; reset stevca
        MOV     TH0,#0            ;
        MOV     R5,#CL590         ; Obrisi 590 !
        ACALL   SET137            ;
        MOV     R5,#SLED          ; prizgi led (ugasni 590!)
        ACALL   SET137            ;
        MOV     U374,#11011111B   ; Init
        MOV     NRCA,#8           ; Cas trajanja meritve  (4,8)
; --------------------------------------------------------------------------
; Nastavitev hitrosti merjenja
; --------------------------------------------------------------------------
        MOV     R2,NRCA           ; Set bitov glede na cas
        CJNE    R2,#4 INIX        ;
        MOV     A,U374            ;
        SETB    ACC.5             ;
        MOV     U374,A            ;
INIX:                             ;
; --------------------------------------------------------------------------
        MOV     P1,U374           ; Podatki, ki so od prej
        CLR     P3.3              ; DOL
        SETB    P3.3              ; GOR in je vpisano
        MOV     TMOD,#05H         ; Timer0 - 16 bit counter
        SETB    TCON.4            ;
        SETB    TCON.0            ; Prekinitev ob prehodu navzdol.
        SETB    IE.0              ; Dovoljenje za zunanjo pr. nr 0 !
        SETB    IE.7              ; Hooj prekinitve laufajo !
        MOV     NRMR,#10          ; Stevilo meritev za povprecenje
; --------------------------------------------------------------------------
; Glavna zanka
; --------------------------------------------------------------------------
        MOV     POT,#'0'          ;
        MOV     A,#84             ; V zadnjo vrstico izpisi
        ADD     A,#LCDDADR        ;
        ACALL   WRIINS            ; text, ki je na naslovu
        ACALL   DEL1MS            ;
        MOV     DPTR,#OBMOC       ; obmoc
        ACALL   OUTSTR            ;
        MOV     A,#0              ; V zadnjo vrstico izpisi
        ADD     A,#LCDDADR        ;
        ACALL   WRIINS            ; text, ki je na naslovu
        ACALL   DEL1MS            ;
        MOV     DPTR,#EXT         ; Zunanji vhod
        ACALL   OUTSTR            ;
        MOV     A,#64             ; V zadnjo vrstico izpisi
        ADD     A,#LCDDADR        ;
        ACALL   WRIINS            ; text, ki je na naslovu
        ACALL   DEL1MS            ;
        MOV     DPTR,#V12         ; Zunanji vhod
        ACALL   OUTSTR            ;

        MOV     A,#1              ; zacetna vrednost razmerja meritev
        MOV     ZANK,A            ;
GZANKA:                           ;
        MOV     A,ZANK            ; Primerjaj ce je ze cas za meritev obmocja
        DEC     A                 ; Zmanjsaj stevec prehodov
        MOV     ZANK,A            ; shrani
        CJNE    A,#0 GZANK1       ; ce ni nula preskoci meritev obmocja
        MOV     A,#5              ; drugace postavi v stevec 20 in
        MOV     ZANK,A            ; shrani, ter izmeri obmocje

        MOV     NRMR,#2           ; za meritev mej  povprecenje z 2

        MOV     A,U374            ; Preklopi na levo mejo
        CLR     ACC.4             ;
        CLR     ACC.6             ;
        SETB    ACC.7             ;
        MOV     U374,A            ;
        MOV     P1,U374           ;
        CLR     P3.3              ;
        SETB    P3.3              ;

        ACALL   VCO1              ;
        ACALL   VCO1              ;
        ACALL   VCO2              ;
        ACALL   IZRMF             ; izracunaj rezultat - upostevaj MF
        MOV     DMELE+0,OP_0
        MOV     DMELE+1,OP_1
        MOV     DMELE+2,OP_2
        MOV     DMELE+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#90             ; in izpisi na poziciji 90 LCD-ja
        ACALL   PI4DEC            ; s samo stirimi znaki

        MOV     A,U374            ; Preklopi na desno mejo
        CLR     ACC.4             ;
        SETB    ACC.6             ;
        SETB    ACC.7             ;
        MOV     U374,A            ;
        MOV     P1,U374           ;
        CLR     P3.3              ;
        SETB    P3.3              ; Vpisi !

        ACALL   VCO1              ;
        ACALL   VCO1              ;
        ACALL   VCO2              ;
        ACALL   IZRMF             ; izracunaj rezultat - upostevaj MF
        MOV     DMEDE+0,OP_0
        MOV     DMEDE+1,OP_1
        MOV     DMEDE+2,OP_2
        MOV     DMEDE+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#96             ; in izpisi na poziciji 90 LCD-ja
        ACALL   PI4DEC            ; s samo stirimi znaki
GZANK1: MOV     A,U374            ; Vrni na potenciometer
        SETB    ACC.4             ;
        SETB    ACC.6             ;
        SETB    ACC.7             ;
        MOV     U374,A            ;
        MOV     P1,U374           ;
        CLR     P3.3              ;
        SETB    P3.3              ;
        ACALL   VCO1              ; Izmeri VCO1
        MOV     NRMR,#10          ;
        ACALL   VCO1              ; Izmeri VCO1
        ACALL   VCO2              ; Izmeri VCO2
; --------------------------------------------------------------------------
; Prvi  rezultat v Ghz ( VCO #2)
; --------------------------------------------------------------------------
        MOV     OP_0,RE1+2        ; Rezultat v OP
        MOV     OP_1,RE1+1        ;
        MOV     OP_2,RE1          ;
        MOV     OP_3,#0           ;
        ACALL   PRETV             ; impulz.->rezultat (presk.,cas,meritve)
        MOV     DVCO2+0,OP_0
        MOV     DVCO2+1,OP_1
        MOV     DVCO2+2,OP_2
        MOV     DVCO2+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#75             ; in izpisi na poziciji 64 LCD-ja
        ACALL   PISDEC            ;
; --------------------------------------------------------------------------
; Drugi rezultat v Ghz ( VCO #1)
; --------------------------------------------------------------------------
        MOV     OP_0,RE2+2        ; Rezultat v OP
        MOV     OP_1,RE2+1        ;
        MOV     OP_2,RE2          ;
        MOV     OP_3,#0           ;
        ACALL   PRETV             ; impulz.->rezultat (presk.,cas,meritve)
        MOV     DVCO1+0,OP_0
        MOV     DVCO1+1,OP_1
        MOV     DVCO1+2,OP_2
        MOV     DVCO1+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#68             ; in izpisi na poziciji 72 LCD-ja
        ACALL   PISDEC            ;

        ACALL   IZRMF             ; izracunaj rezultat - upostevaj MF
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#20             ; in izpisi na poziciji 20 LCD-ja
        ACALL   PISDEC            ;
;
        ACALL   VCO3
; --------------------------------------------------------------------------
; Tretji rezultat v Ghz ( VCO zunanji)
; --------------------------------------------------------------------------
        MOV     OP_0,RE3+2        ; Rezultat v OP
        MOV     OP_1,RE3+1        ;
        MOV     OP_2,RE3          ;
        MOV     OP_3,#0           ;
        ACALL   PRETV             ; impulz.->rezultat (presk.,cas,meritve)
        MOV     DVCX1+0,OP_0
        MOV     DVCX1+1,OP_1
        MOV     DVCX1+2,OP_2
        MOV     DVCX1+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#11             ; in izpisi na poziciji 64 LCD-ja
        ACALL   PISDEC            ;

        ACALL   VCO4
; --------------------------------------------------------------------------
; Cetrti rezultat v Mhz ( VCO 2 zunanji)
; --------------------------------------------------------------------------
        MOV     OP_0,RE4+2        ; Rezultat v OP
        MOV     OP_1,RE4+1        ;
        MOV     OP_2,RE4          ;
        MOV     OP_3,#0           ;
        ACALL   PRETV             ; impulz.->rezultat (presk.,cas,meritve)
        MOV     DVCX2+0,OP_0
        MOV     DVCX2+1,OP_1
        MOV     DVCX2+2,OP_2
        MOV     DVCX2+3,OP_3
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#31             ; in izpisi na poziciji 64 LCD-ja
        ACALL   PISDEC            ;



;       MOV     A,#31             ; V tretjo vrstico izpisi
;       ADD     A,#LCDDADR        ;
;       ACALL   WRIINS            ; text, ki je na naslovu
;       ACALL   DEL1MS            ;
;       MOV     A,POT             ; potenciometer
;       ACALL   WRIDAT            ;

        MOV     R1,POT            ;

        CJNE    R1,#'0',GZANK2    ;
        CLR     IE.7              ; Hooj prekinitve NE laufajo !

        PUSH    7
        PUSH    6
        PUSH    0
        PUSH    ACC
        MOV     R5,#SLED          ; prizgi led - vodila ne sme
        ACALL   SET137            ; motiti nobena naprava

        MOV     P1,#0FFH          ; Poslji sinhro FF
        MOV     R7,#40            ; 20 ms
        ACALL   DELAYR7           ;
        MOV     P1,#00H           ; Posliji sinhro 00
        MOV     R7,#41            ; potem se 41 ms
        ACALL   DELAYR7           ;
        MOV     R6,#26            ; poslji 24 znakov
        MOV     R0,#DVCO1
GZANK3: MOV     A,@R0             ;
        INC     R0                ; Naslednji znak
        MOV     P1,A              ;
        MOV     R7,#8             ; med vsakim je 20 ms !
        ACALL   DELAYR7           ;
        MOV     R7,#220           ;
GZANK4: NOP                       ; se malo vec je treba
        NOP
        DJNZ    R7,GZANK4         ;
        DJNZ    R6,GZANK3         ; poslani so vsi znaki.
        POP     ACC
        POP     0
        POP     6
        POP     7

        MOV     POT,#'1'
        SETB    IE.7              ; Hooj prekinitve laufajo !
GZANK2:


        AJMP    GZANKA            ; do vecnosti..hi
OBMOC:  DB      'Obm.:     -      Mhz',0
EXT:    DB      'Zun.vhod:        Mhz',0
V12:    DB      'VCO              Mhz',0
; --------------------------------------------------------------------------
; Procedure
; --------------------------------------------------------------------------
; Izracun rezultata  VCO1-VCO2-MF !   MV=70.7 Mhz
; --------------------------------------------------------------------------
IZRMF:  MOV     OP_0,RE2+2        ; Rezultat VCO2 v OP
        MOV     OP_1,RE2+1        ;
        MOV     OP_2,RE2          ;
        MOV     OP_3,#0           ;
        MOV     SUB32+3,RE1+2     ; Rezultat VCO1 v SUB32
        MOV     SUB32+2,RE1+1     ;
        MOV     SUB32+1,RE1       ;
        MOV     SUB32+0,#0        ;
        ACALL   SUB_32            ; Odstej
        ACALL   PRETV             ; impulz.->rezultat (presk.,cas,meritve)
        MOV     SUB32+0,#0        ;
        MOV     SUB32+1,#0        ; Odstej se medfrekvenco
        MOV     SUB32+2,#2        ;
        MOV     SUB32+3,#195      ;
        ACALL   SUB_32            ;
        RET                       ;

; --------------------------------------------------------------------------
; Meri VCO1
; --------------------------------------------------------------------------
VCO1:   MOV     A,U374            ;
        CLR     ACC.2             ; Vhod 1
        CLR     ACC.3             ;
        ACALL   IZMERI            ;
        MOV     RE1,RE            ; Premakni v rezultat 1
        MOV     RE1+1,RE+1        ;
        MOV     RE1+2,RE+2        ;
        RET                       ;

; --------------------------------------------------------------------------
; Meri VCO2
; --------------------------------------------------------------------------
VCO2:   MOV     A,U374            ;
        SETB    ACC.3             ; Vhod 2
        SETB    ACC.2             ;
        ACALL   IZMERI            ;
        MOV     RE2,RE            ; Premakni v rezultat 2
        MOV     RE2+1,RE+1        ;
        MOV     RE2+2,RE+2        ;
        RET                       ;

; --------------------------------------------------------------------------
; Meri VCO3
; --------------------------------------------------------------------------
VCO3:   MOV     A,U374            ;
        CLR     ACC.3             ; Vhod 3
        SETB    ACC.2             ;
        ACALL   IZMERI            ;
        MOV     RE3,RE            ; Premakni v rezultat 2
        MOV     RE3+1,RE+1        ;
        MOV     RE3+2,RE+2        ;
        RET                       ;

; --------------------------------------------------------------------------
; Meri VCO4
; --------------------------------------------------------------------------
VCO4:   MOV     A,U374            ;
;       SETB    ACC.3             ;
;       CLR     ACC.2             ; Vhod 4
        CLR     ACC.3             ;   ZACASNO 1
        SETB    ACC.2             ;        VHOD !
        ACALL   IZMERI            ;
        MOV     RE4,RE            ; Premakni v rezultat 2
        MOV     RE4+1,RE+1        ;
        MOV     RE4+2,RE+2        ;
        RET                       ;

; --------------------------------------------------------------------------
; Pretvorba glede na cas merjenja in stevilo vzorcev.
; --------------------------------------------------------------------------
PRETV:  MOV     DIV16,#0          ; Povprecenje..deljeno s stevilom
        MOV     DIV16+1,NRMR      ; meritev
        ACALL   DIV_16            ;
        MOV     MUL16,#0          ; pomnozi z 128 ( preskaler)
        MOV     MUL16+1,#32       ; (hmm.. mnozi s 32 in kasneje deli s 5)
        ACALL   MUL_16            ; (rezultat se tako lazje ohranja v mejah)
        MOV     DIV16,#0          ;
        MOV     DIV16+1,NRCA      ; deli casovno konstanto
        ACALL   DIV_16            ;
        MOV     DIV16,#0          ;
        MOV     DIV16+1,#5        ; deli s 20
        ACALL   DIV_16            ;
        RET                       ;

; --------------------------------------------------------------------------
; Pretvorba glede na cas merjenja in stevilo vzorcev. SAMO VCOX2 !
; tu ne delimo s 128, ker na tem vhodu ni preskalerja !
; --------------------------------------------------------------------------
PRETV4: MOV     DIV16,#0          ; Povprecenje..deljeno s stevilom
        MOV     DIV16+1,NRMR      ; meritev
        ACALL   DIV_16            ;
        MOV     DIV16,#0          ;
        MOV     DIV16+1,NRCA      ; deli casovno konstanto
        ACALL   DIV_16            ;
        MOV     DIV16,#0          ;
        MOV     DIV16+1,#20       ; deli s 20
        ACALL   DIV_16            ;
        RET
; --------------------------------------------------------------------------
; Meritev na enem od portov
; --------------------------------------------------------------------------
IZMERI: MOV     U374,A            ; Shrani v U374
        MOV     P1,U374           ; Premik na port
        SETB    P3.3              ; DOL
        SETB    P3.3              ; GOR in je vpisano
        MOV     NRIN,NRMR         ; Stevilo meritev je 10
        MOV     MERI,#1           ; Zahtevaj meritev v interrupt rutini
IZMERI1:MOV     R5,#CTIPKE        ; Selekt sitanje tipk
        CALL    SET137            ;
        SETB    P1.0              ;
        SETB    P1.1              ;
        SETB    P1.2              ; maska - katere tipke sploh citamo
        MOV     TMP_0,P1          ;
        MOV     R5,#SLED          ; Deselekt vseh enot - prizgi LED
        CALL    SET137            ;
        MOV     A,TMP_0           ;
        JB      ACC.2,IZMERI2     ;
        MOV     POT,#'2'          ; Pritisnjena tipka 2
IZMERI2:JB      ACC.1,IZMERI3     ;
        MOV     POT,#'1'          ; Pritisnjena tipka 1
IZMERI3:JB      ACC.0,IZMERI4     ;
        MOV     POT,#'0'          ; Pritisnjena tipka 0  ****PRENOS ? ****
IZMERI4:MOV     A,#0              ;
        CJNE    A,MERI IZMERI1    ; Cakaj dokler meritev ni koncana
        RET                       ;
; --------------------------------------------------------------------------
; Izpisi prvi rezultat v Mhz pred preskalerjem
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; Rutina ni uporabljena in je tu dokler je program v razvoju !
; --------------------------------------------------------------------------
IZRE1:  MOV     OP_0,RE1+2        ; Rezultat v OP
        MOV     OP_1,RE1+1        ;
        MOV     OP_2,RE1          ;
        MOV     OP_3,#0           ;
        MOV     MUL16,#0          ; pomnozi z 5
        MOV     MUL16+1,#5        ;
        ACALL   MUL_16            ;
        MOV     DIV16,#0          ; Ja ok rezultat delis z 8
        MOV     DIV16+1,NRCA      ; zaradi trajanja casovne
        ACALL   DIV_16            ; baze
        MOV     DIV16,#0          ; Povprecenje..deljeno s stevilom
        MOV     DIV16+1,NRMR      ; meritev
        ACALL   DIV_16            ;
        ACALL   BIN2DEC           ; Izpisi prvi rezultat - pretvori
        MOV     A,#0              ; Pisi na 0 adresi LCD -ja
        ACALL   PISDEC            ;
        RET                       ;
; --------------------------------------------------------------------------
; Izpisi drugi rezultat v Mhz pred preskalerjem
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; Rutina ni uporabljena in je tu dokler je program v razvoju !
; --------------------------------------------------------------------------
IZRE2:  MOV     OP_0,RE2+2        ; Rezultat v OP
        MOV     OP_1,RE2+1        ;
        MOV     OP_2,RE2          ;
        MOV     OP_3,#0           ;
        MOV     MUL16,#0          ; pomnozi z 5
        MOV     MUL16+1,#5        ;
        ACALL   MUL_16            ;
        MOV     DIV16,#0          ; Ja ok rezultat delis z 8
        MOV     DIV16+1,NRCA      ; zaradi trajanja casovne
        ACALL   DIV_16            ; baze
        MOV     DIV16,#0          ; povprecenje..deljeno s stevilom
        MOV     DIV16+1,NRMR      ; meritev
        ACALL   DIV_16            ;
        ACALL   BIN2DEC           ; pretvori iz bin v dec
        MOV     A,#8              ; Pisi na 8 adresi LCD -ja
        ACALL   PISDEC            ;
        RET                       ;
; --------------------------------------------------------------------------
; Setiranje 137 preko maske
; --------------------------------------------------------------------------
SET137: MOV     A,POU3            ; Programski latch za P3 reg.
        ANL     A,#MASK137        ;
        ORL     A,R5              ;
        MOV     P3,A              ;
        MOV     POU3,A            ;
        RET                       ;
; --------------------------------------------------------------------------
; Izpis registrov na LCD
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; Rutina ni uporabljena in je tu dokler je program v razvoju !
; na LCD izpisuje vsebino registrov, pri cemer njihove vsebine ne poskoduje
; --------------------------------------------------------------------------
DISPR:  PUSH    7                 ; Shranimo registre na SP
        PUSH    6                 ; da rutina sama nebi zmotila
        PUSH    5                 ; delovanja..
        PUSH    4                 ;
        PUSH    3                 ;
        PUSH    2                 ;
        PUSH    1                 ;
        PUSH    0                 ; R0
        MOV     R0,B              ; shrani se b
        PUSH    0                 ;
        MOV     R0,A              ;
        PUSH    0                 ;
        MOV     R0,0D0H           ; PSW
        PUSH    0                 ;
        MOV     R0,POU3           ;
        PUSH    0                 ;
        MOV     R0,P1             ;
        PUSH    0                 ;
        MOV     R0,089H           ; TCON
        PUSH    0                 ;
        MOV     R0,088H           ; TMOD
        PUSH    0                 ;
        MOV     R0,0A8H           ; IE
        PUSH    0                 ;
        MOV     R0,08DH           ; TH1
        MOV     R1,08BH           ; TL1
        PUSH    0                 ;
        PUSH    1                 ;
        MOV     R0,08CH           ; TH0
        MOV     R1,08AH           ; TL0
        PUSH    0                 ;
        PUSH    1                 ;
        MOV     A,#LCDDADR        ;
        ACALL   WRIINS            ;
        ACALL   DEL1MS            ; Obvezno pocakaj
        MOV     DPTR,#WRX         ; Izpisi glavo !
        ACALL   OUTSTR            ;
        MOV     R4,#14H           ; Izpisi se 20 pozicij
        MOV     R1,81H            ; iz stacka
DISPR1: ACALL   PISREG            ;
        DEC     R1                ;
        DJNZ    R4,DISPR1         ;
        POP     0                 ; Sedaj pa pazi da ne povozis stevcev !
        POP     0                 ;
        POP     0                 ;
        POP     0                 ;
        POP     0                 ;
        MOV     0A8H,R0           ; Ostalo pa lepo vrni
        POP     0                 ;
        MOV     088H,R0           ;
        POP     0                 ;
        MOV     089H,R0           ;
        POP     0                 ;
        POP     0                 ;
        MOV     P3,POU3           ;
        POP     0                 ;
        MOV     0D0H,R0           ;
        POP     0                 ;
        MOV     A,R0              ;
        POP     0                 ;
        MOV     B,R0              ;
        POP     0                 ;
        POP     1                 ;
        POP     2                 ;
        POP     3                 ;
        POP     4                 ;
        POP     5                 ;
        POP     6                 ;
        POP     7                 ;
        RET                       ;
WRX:    DB 'T0  T1  IETMTCP1P3PS A B 0 1 2 3 4 5 6 7',0
; --------------------------------------------------------------------------
; Izpis memorijske lokacije Hexa na LCD
; --------------------------------------------------------------------------
; --------------------------------------------------------------------------
; Rutina ni uporabljena in je tu dokler je program v razvoju !
; na LCD izpisuje vsebino registrov, pri cemer njihove vsebine ne poskoduje
; --------------------------------------------------------------------------
PISREG: MOV     A,@R1             ; Naslov je v R1
        SWAP    A                 ;
        ANL     A,#0FH            ; Najprej H del
        ACALL   NUM2CH            ; Pretvori v cifro
        ACALL   WRIDAT            ; in izpisi
        MOV     A,@R1             ; potem se L del
        ANL     A,#0FH            ;
        ACALL   NUM2CH            ; Pretvori v cifro
        ACALL   WRIDAT            ; in izpisi
        RET                       ;
; --------------------------------------------------------------------------
; Inicializacija displeja
; --------------------------------------------------------------------------
LCDINIT: MOV     DPTR,#LINT       ; DPTR na podatke
LCDINI1: CLR     A                ; Obrisi A
         MOVC    A,@A+DPTR        ; Premakni v A stevec  ponovitev
         JZ      LCDINI3          ; Ce je 0 koncaj
         MOV     R6,A             ; Izvedi
LCDINI2: ACALL   DEL1MS           ;        zakasnitve
         DJNZ    R6,LCDINI2       ;
         INC     DPTR             ; Naslednji podatek
         CLR     A                ;
         MOVC    A,@A+DPTR        ; Premakni v A in ga zapisi
         ACALL   WRIINS           ; v instrukciski register
         INC     DPTR             ;
         SJMP    LCDINI1          ;
LCDINI3: RET                      ; To je vse
                                  ;
LINT:    DB      14 ,LCDINT       ; Inicializacija
         DB      06H,LCDINT       ; Inicializacija
         DB      01H,LCDINT       ; Inicializacija
         DB      01H,LCD5X7       ; 2.vrstici, 5x7 pixlov
         DB      01H,LCDON        ; Prizgi LCD
         DB      01H,LCDCLR       ; Obrisi vsebino
         DB      01H,LCDHOME      ; Kurzor na zacetek
         DB      00H              ; Koncaj.

; --------------------------------------------------------------------------
; Procedura izpisuje 0 term. string na LCD
; Naslov stringa damo v DPTR register
; --------------------------------------------------------------------------
OUTSTR:	CLR     A                 ;
        MOVC    A,@A+DPTR         ; Vzemi znak
        JZ      OUTST1            ; konec ko je 0
        ACALL   WRIDAT            ; Pisi znak na LCD
        INC     DPTR              ; naslednji znak
        SJMP    OUTSTR            ;
OUTST1: RET                       ; To je vse

; --------------------------------------------------------------------------
; Procedura vpise vsebino v A  v instr.  ali  data register
; WRIDAT - vpis v data register
; WRIINS - vpis v Iinstrukcijski register
; --------------------------------------------------------------------------
WRIDAT: MOV     P1,U374           ; Podatki, ki so od prej
        SETB    P1.0              ; Nastavitev data registra
        SJMP    WRID01            ; Naprej isto kot pri inst
WRIINS: MOV     P1,U374           ;
        CLR     P1.0              ; Nastavitev instr. regista
WRID01: CLR     P1.1              ; Vpisovali bomo
        MOV     U374,P1           ;
        CLR     P3.3              ; DOL
        SETB    P3.3              ; GOR in je vpisano
        MOV     P1,A              ; Vpis data na P1
        MOV     R5,#ENLCD         ; Enable LCD
        ACALL   SET137            ;
        ACALL   DEL1MS            ; Cakaj
        MOV     R5,#SLED          ; Disable LCD
        ACALL   SET137            ;
        RET                       ; To je vse

; --------------------------------------------------------------------------
; Zakasnitev 1 ms za takt 11.059 ( brez prekinitev..hi)
; --------------------------------------------------------------------------
DEL1MS: PUSH ACC                  ; Shrani ACC,B in R7
        PUSH B                    ;
        PUSH 7                    ;
	MOV R7,#150               ; 150 x podeli
        MOV A,#01H                ; 1 z
        MOV B,#01H                ;     1
DEL1M1: DIV AB                    ;
	DJNZ R7,DEL1M1            ;
        POP 7                     ; Vrni vsebino registrov
        POP B                     ;
        POP ACC                   ;
	RET                       ;

; --------------------------------------------------------------------------
; Zakasnitev za R7 ms
; --------------------------------------------------------------------------
DELAYR7:LCALL   DEL1MS            ;
	DJNZ    R7,DELAYR7        ; R7 x poklici zakasnitev 1 ms.
	RET                       ;

; --------------------------------------------------------------------------
; Izpis petmestnega decimalnega stevila na LCD
; --------------------------------------------------------------------------
PISDEC: ADD     A,#LCDDADR        ;
        ACALL   WRIINS            ;
        ACALL   DEL1MS            ; Obvezno pocakaj
        MOV     R1,#5             ;
        MOV     R0,#DSP_5         ;
PISDE1: MOV     A,@R0             ;
        ACALL   NUM2CH            ;
        ACALL   WRIDAT            ; in izpisi
        CJNE    R1,#2 PISDE2
        MOV     A,#'.'
        ACALL   WRIDAT
PISDE2:
        DEC     R0                ;
        DJNZ    R1,PISDE1         ;
        RET                       ;
; --------------------------------------------------------------------------
; Izpis stirimestnega decimalnega stevila na LCD
; --------------------------------------------------------------------------
PI4DEC: ADD     A,#LCDDADR        ; Pisi na pozicijo A
        ACALL   WRIINS            ;
        ACALL   DEL1MS            ; Obvezno pocakaj
        MOV     R1,#4             ;
        MOV     R0,#DSP_5         ;
PI4DE1: MOV     A,@R0             ;
        ACALL   NUM2CH            ;
        ACALL   WRIDAT            ; in izpisi
        DEC     R0                ;
        DJNZ    R1,PI4DE1         ;
        RET                       ;
; --------------------------------------------------------------------------
; Rutina pretvori binarni zapis v decimalnega
; VHOD:  INDATA
; IZHOD: DSP_1   ENICE
;        DSP_2   DESETICE
;        DSP_3   STOTICE
;        DSP_4   TISOCICE
;        DSP_5   DESETTISOCICE
; --------------------------------------------------------------------------
BIN2DEC:                          ;
        MOV     INDATA,OP_1       ;  Vhodni podatki
        MOV     INDATA+1,OP_0     ;
        MOV     DI,#39            ;  10000 ---> DI
        MOV     DI+1,#16          ;
        ACALL   MESTO             ;  Rezultat je vedno v DSP_1
        MOV     DSP_5,DSP_1       ;
        MOV     INDATA,OP_1       ;  OP_0,OP_1 je ostanek
        MOV     INDATA+1,OP_0     ;
        MOV     DI,#3             ;  1000 ---> DI
        MOV     DI+1,#232         ;
        ACALL   MESTO             ;  Rezultat je vedno v DSP_1
        MOV     DSP_4,DSP_1       ;
        MOV     INDATA,OP_1       ;  OP_0,OP_1 je ostanek
        MOV     INDATA+1,OP_0     ;
        MOV     DI,#0             ;
        MOV     DI+1,#100         ;  100 ----> DI
        ACALL   MESTO             ;
        MOV     DSP_3,DSP_1       ;
        MOV     INDATA,OP_1       ;
        MOV     INDATA+1,OP_0     ;
        MOV     DI,#0             ;
        MOV     DI+1,#10          ;  10 -----> DI
        ACALL   MESTO             ;
        MOV     DSP_2,DSP_1       ;
        MOV     DSP_1,OP_0        ;
        RET                       ;
; --------------------------------------------------------------------------
; Rutina izpise posamezno decimalno mesto
; --------------------------------------------------------------------------
MESTO:  MOV     SET16,INDATA      ; Vhodni podatki --> 1.argument
        MOV     SET16+1,INDATA+1  ; za matematicne operacije
        ACALL   LOAD_16           ;
        MOV     DIV16,DI          ; Deli s faktorjem v DI
        MOV     DIV16+1,DI+1      ;
        ACALL   DIV_16            ;
        MOV     DSP_1,OP_0        ; Rezultat v DSP_1
        MOV     SET16+1,OP_0      ; Rezultat napolni v prvi argument
        MOV     SET16,#0          ; Priprava za iskanje razlike
        ACALL   LOAD_16           ;
        MOV     MUL16,DI          ; Mnozi z DI !
        MOV     MUL16+1,DI+1      ;
        ACALL   MUL_16            ;
        MOV     SUB16+1,OP_0      ; Rezultat odstej od podatkov
        MOV     SUB16,OP_1        ;
        MOV     SET16,INDATA      ; Vhodni podatki gredo c LOAD16
        MOV     SET16+1,INDATA+1  ;
        ACALL   LOAD_16           ; Napolni
        ACALL   SUB_16            ; Odstej !
        RET                       ; Rezultat je v OP_?
                                  ;
; --------------------------------------------------------------------------
; Pretvorba iz stevilk v character
; --------------------------------------------------------------------------
NUM2CH: MOV     DPTR,#CIFRE       ; DPTR na start tabele CIFRE
        MOVC    A,@A+DPTR         ; A je odmik od zacetka tabele
        RET                       ;
CIFRE:  DB  '0123456789ABCDEF',0  ;
; --------------------------------------------------------------------------
; Matematicni del 32bitne aritmetike
; --------------------------------------------------------------------------
LOAD_16:
; --------------------------------------------------------------------------
; Premik 16 bitnega stevila v operand
; --------------------------------------------------------------------------
        MOV     OP_3,#0           ;
        MOV     OP_2,#0           ;
        MOV     OP_1,SET16        ;
        MOV     OP_0,SET16 + 1    ;
        RET                       ;

; --------------------------------------------------------------------------
; Premik 32 bitnega stevila v operand
; --------------------------------------------------------------------------
LOAD_32:MOV     OP_3,SET32        ;
        MOV     OP_2,SET32 + 1    ;
        MOV     OP_1,SET32 + 2    ;
        MOV     OP_0,SET32 + 3    ;
        RET                       ;
                                  ;
; --------------------------------------------------------------------------
; Premik spodnjega dela 32 bitnega stevila v R6,R7
; --------------------------------------------------------------------------
LOW_16: MOV     R6,OP_1           ;
        MOV     R7,OP_0           ;
        RET                       ;
                                  ;
; --------------------------------------------------------------------------
; Premik srednjega dela 32 bitnega stevila v R6,R7
; --------------------------------------------------------------------------
MID_16: MOV     R6,OP_2           ;
        MOV     R7,OP_1           ;
        RET                       ;
                                  ;
; --------------------------------------------------------------------------
; Premik gornjega dela 32 bitnega stevila v R6,R7
; --------------------------------------------------------------------------
HIGH_16:MOV     R6,OP_3           ;
        MOV     R7,OP_2           ;
        RET                       ;

; --------------------------------------------------------------------------
; Sestevanje 32 bitnega stevila z 16 bitnim stevilom -> OP_0..OP_3
; -------------------------------------------------------------------------- CLR     C                 ;
ADD_16: MOV     A,OP_0            ;
        ADDC    A,ADD16 + 1       ; Najprej spodnji by
        MOV     OP_0,A            ;
        MOV     A,OP_1            ;
        ADDC    A,ADD16           ; naslednji by + carry
        MOV     OP_1,A            ;
        MOV     A,OP_2            ;
        ADDC    A,#0              ; samo se carry
        MOV     OP_2,A            ;
        MOV     A,OP_3            ;
        ADDC    A,#0              ; samo se carry
        MOV     OP_3,A            ;
        RET                       ;

; --------------------------------------------------------------------------
; Sestevanje 32 bitnega stevila z 32 bitnim stevilom -> OP_0..OP_3
; --------------------------------------------------------------------------
ADD_32: CLR     C                 ;
        MOV     A,OP_0            ;
        ADDC    A,ADD32 + 3       ; Najprej spodnji by
        MOV     OP_0,A            ;
        MOV     A,OP_1            ;
        ADDC    A,ADD32 + 2       ; naslednji byte + carry
        MOV     OP_1,A            ;
        MOV     A,OP_2            ;
        ADDC    A,ADD32 + 1       ; naslednji byte + carry
        MOV     OP_2,A            ;
        MOV     A,OP_3            ;
        ADDC    A,ADD32           ; zadnji byte + carry
        MOV     OP_3,A            ;
        RET                       ;

; --------------------------------------------------------------------------
; Odstevanje 16 bitnega stevila od 32 bitnega stevila -> OP_0..OP_3
; --------------------------------------------------------------------------
SUB_16: CLR     C                 ;
        MOV     A,OP_0            ;
        SUBB    A,SUB16 + 1       ; Najprej spodnji by
        MOV     OP_0,A            ;
        MOV     A,OP_1            ;
        SUBB    A,SUB16           ; naslednji byte + carry
        MOV     OP_1,A            ;
        MOV     A,OP_2            ;
        SUBB    A,#0              ; naslednji byte + carry
        MOV     OP_2,A            ;
        MOV     A,OP_3            ;
        SUBB    A,#0              ; zadnji byte + carry
        MOV     OP_3,A            ;
        RET                       ;

; --------------------------------------------------------------------------
; Odstevanje 32 bitnega stevila od 32 bitnega stevila -> OP_0..OP_3
; --------------------------------------------------------------------------
SUB_32: CLR     C                 ;
        MOV     A,OP_0            ;
        SUBB    A,SUB32 + 3       ; Najprej spodnji by
        MOV     OP_0,A            ;
        MOV     A,OP_1            ;
        SUBB    A,SUB32 + 2       ; naslednji byte + carry
        MOV     OP_1,A            ;
        MOV     A,OP_2            ;
        SUBB    A,SUB32 + 1       ; naslednji byte + carry
        MOV     OP_2,A            ;
        MOV     A,OP_3            ;
        SUBB    A,SUB32           ; zadnji byte + carry
        MOV     OP_3,A            ;
        RET                       ;

; --------------------------------------------------------------------------
; Mnozenje 32 bitnega stevila z 16 bitnim stevilom -> OP_0..OP_3
; --------------------------------------------------------------------------
MUL_16: MOV     TMP_3,#0          ; Obrisi zgornjih 16 bitov
        MOV     TMP_2,#0          ;
        MOV     B,OP_0            ; Pripravi spodji by rezultata
        MOV     A,MUL16+1         ;
        MUL     AB                ;
        MOV     TMP_0,A           ; spodnji del rezultata
        MOV     TMP_1,B           ; zgornji del rezultata
        MOV     B,OP_1            ; Pripravi naslednji by za rezultat
        MOV     A,MUL16+1         ;
        MUL     AB                ;
        ADD     A,TMP_1           ; spodnji del rezultata
        MOV     TMP_1,A           ; shrani
        MOV     A,B               ; vzemi zgornji del rezultata
        ADDC    A,TMP_2           ; sestej in upostevaj carry prejsnje
        MOV     TMP_2,A           ; operacije in shrani.
        JNC     MUL_LOOP1         ;
        INC     TMP_3             ; postavi carry v TMP_3
MUL_LOOP1:                        ;
        MOV     B,OP_0            ;
        MOV     A,MUL16           ;
        MUL     AB                ;
        ADD     A,TMP_1           ; spodnji del rezultata
        MOV     TMP_1,A           ; shrani
        MOV     A,B               ; vzemi zgornji del rezultata
        ADDC    A TMP_2           ; sestej in upostevaj carry prejsnje
        MOV     TMP_2,A           ; operacije in shrani.
        JNC     MUL_LOOP2         ;
        INC     TMP_3             ; postavi carry v TMP_3
MUL_LOOP2:                        ;
        MOV     B,OP_2            ; Tu se zacne delo za tretji by
        MOV     A,MUL16+1         ;
        MUL     AB                ;
        ADD     A,TMP_2           ; spodnji del rezultata
        MOV     TMP_2,A           ; shrani
        MOV     A,B               ; vzemi zgornji del rezultata
        ADDC    A,TMP_3           ; sestej in upostevaj carry prejsnje
        MOV     TMP_3,A           ; operacije in shrani.
        MOV     B,OP_1            ; Zdaj se preostalo polovico
        MOV     A,MUL16           ;
        MUL     AB                ;
        ADD     A,TMP_2           ; spodnji del rezultata
        MOV     TMP_2,A           ; shrani
        MOV     A,B               ; vzemi zgornji del rezultata
        ADDC    A,TMP_3           ; sestej in upostevaj carry prejsnje
        MOV     TMP_3,A           ; operacije in shrani.
        MOV     B,OP_3            ; Koncaj se najvisji by
        MOV     A,MUL16+1         ;
        MUL     AB                ;
        ADD     A,TMP_3           ; spodnji del rezultata
        MOV     TMP_3,A           ; shrani
        MOV     B,OP_2            ; Zgornji del ? ni ! (32bit math)
        MOV     A,MUL16           ;
        MUL     AB                ;
        ADD     A,TMP_3           ; spodnji del rezultata
        MOV     TMP_3,A           ; shrani
        SJMP    TMPOP             ; Premakni vse TMP v OP
                                  ;
; --------------------------------------------------------------------------
; Deljenje 32 bitnega stevila z 16 bitnim stevilom -> OP_0..OP_3
; --------------------------------------------------------------------------
DIV_16: MOV     R7,#0             ;
        MOV     R6,#0             ; Obrisi ostanek
        MOV     TMP_0,#0          ;
        MOV     TMP_1,#0          ;
        MOV     TMP_2,#0          ;
        MOV     TMP_3,#0          ;
        MOV     R1,DIV16          ; pripravi divisor
        MOV     R0,DIV16+1        ;
        MOV     R5,#32            ; delaj za 32 bitov
DIV_LOOP:                         ; Tu se zacne zanka
        CALL    SHIFT_D           ; premakni dividend in vrni MSB in C
        MOV     A,R6              ; premakni Carry v LSB ostanka
        RLC     A                 ;
        MOV     R6,A              ;
        MOV     A,R7              ;
        RLC     A                 ;
        MOV     R7,A              ; testiraj ce je R7:R6 >= R1:R0
        CLR     C                 ;
        MOV     A,R7              ; odstej R1 od R7 da bi videl ce je R1 < R7
        SUBB    A,R1              ; A = R7 - R1, carry je 1 ce je  R7 < R1
        JC      CANT_SUB          ; Tu je  R7>=R1
        JNZ     CAN_SUB           ; skoci ce je R7>R1
        CLR     C                 ; ce je R7= 1, test za R6>=R0
        MOV     A,R6              ;
        SUBB    A,R0              ; A=R6-R0, carry je 1 ce je R6<R0
        JC      CANT_SUB          ;
CAN_SUB:CLR     C                 ; odsterj divisor od dela ostanka
        MOV     A,R6              ;
        SUBB    A,R0              ; A=R6-R0
        MOV     R6,A              ;
        MOV     A,R7              ;
        SUBB    A,R1              ; A=R7-R1-Borrow
        MOV     R7,A              ;
        SETB    C                 ; premakni 1 v kvocient
        JMP     QUOT              ;
CANT_SUB:                         ; premakni 0 v kvocient
        CLR     C                 ;
QUOT:   CALL    SHIFT_Q           ; premakni carry v kvocient
        DJNZ    R5,DIV_LOOP       ; Napravi za vse bite
TMPOP:  MOV     OP_0,TMP_0        ; Koncano ! Premakni vse TMP v OP
        MOV     OP_1,TMP_1        ;
        MOV     OP_2,TMP_2        ;
        MOV     OP_3,TMP_3        ;
        RET                       ; To je vse.
                                  ;
SHIFT_D:MOV     A,R1              ; Shrani R1 regiter...
        CLR     C                 ;
        MOV     R1,#OP_0          ; Naslov premikajocega podrocja
        SJMP    SHD1              ;
SHIFT_Q:MOV     A,R1
        MOV     R1,#TMP_0         ;
SHD1:   MOV     R4,A
        MOV     R3,#4             ; Premikamo 4 by
SHD2:   MOV     A,@R1             ; premakni v A
        RLC     A                 ; rotiraj in
        MOV     @R1,A             ; vrni v spomin
        INC     R1                ; eno dalje
        DJNZ    R3,SHD2           ; ponovi za vse 4 by
        MOV     A,R4              ;
        MOV     R1,A              ; Vrni R1 register...
        RET                       ; to je vse !

        END
