********** program SA *************


{ -------------------------------------------------------------------------
; Prenos podatkov med videopomnilnikom in PC in obratno             V - S10
;
; Program je s strani avtorja dan v javno last dne 22.05.1999.
; Avtor put this program to public domain 22.05.1999.
;
; Program je dovoljeno distribuirati v vseh oblikah, prepovedano
; pa je njegovo koriscenje v komercialne namene, prav tako pa je
; tudi prepovedano  spreminjanje programske kode ali komentarjev
; v programu.
;
; Vse pripombe o delovanju,napakah,ali pa ideje za nove funkcije
; so dobrodosle !
;
; Avtor:  Darko Volk, S57UUD
; Post:   Kacice 15, 6215 Divaca, Slovenija
; E-mail: darko.volksiol.net
; HAM:    @S50BOX.SVN.EU
; Tel:    ++386 67 632-765                                                 }
PROGRAM SA;
{--------------------------------------------------------------------------}
{ Konstante                                                                }
{--------------------------------------------------------------------------}
USES CRT,DOS,GRAPH,VDSCR;
{--------------------------------------------------------------------------}
{** HARDWARE DATA, PARAMETERS AND BIT MASK CONSTANTS**                     }
{--------------------------------------------------------------------------}
CONST COMPORT     :ARRAY[1..4] OF WORD = ($3F8,$2F8,$338,$238);
      COMIRQ      :ARRAY[1..4] OF BYTE = (04,03,02,05);
      COMINT      :ARRAY[1..7] OF BYTE = (09,10,11,12,13,14,15);
      INTMASK     :ARRAY[1..7] OF BYTE = (02,04,08,16,32,64,128);
      EOI8259    =$20;   { Interrupt mode register za EOI                  }
      EOIMASK    =$20;   { maska za EOI                                    }
      ICR8259    =$21;   { Interrupt Control Register PIC                  }
      IEROFF     =1;     {                                                 }
      DTRMASK    =1;     { Maska za SET DTR-bit                            }
      RTSMASK    =2;     { Maska za SET RTS-bit                            }
      CTSMASK    =16;    { Maska za SET CTS-bit                            }
      DSRMASK    =32;    { Maska za SET DSR-bit                            }
      IIROFF     =02;    { Odmiki za Interrupt id.reg                      }
      LCROFF     =03;    {           Line ctrl. reg.                       }
      MCROFF     =04;    {           Modem ctrl. reg.                      }
      LSROFF     =05;    {           Line status reg.                      }
      MSROFF     =06;    {           Modem status reg.                     }
      IRQMASK    =08;    {           Modem ctrl. reg.                      }
      SIZE=8196;         { Dolzina RS232 bufferja                          }

{--------------------------------------------------------------------------}
{ Tipi                                                                     }
{--------------------------------------------------------------------------}
TYPE RESOLUTION=(LOWER,HIGHER); { Definicija rezolucije za VGA             }
     PROC=PROCEDURE;     { Definicija spremenljive procedure               }
{--------------------------------------------------------------------------}
{ Spremenljivke                                                            }
{--------------------------------------------------------------------------}
VAR BUFIX     :WORD;     { Stevec znakov v bufferju                        }
    SER       :BYTE;     {*RS232   - Stevilka porta                        }
    RS232OP   :BOOLEAN;  { RS232   - Je port inicializiran ?               }
    ORGINTMASK:BYTE;     { RS232   - Originalna interrupt maska za 8259    }
    ORGINTVEK :POINTER;  { RS232   - Originalni naslov prekinitvene rutine }
    BAUD      :WORD;     { RS232   - Baud rate                             }
    OUTCHAR   :CHAR;     { RS232   - Poslani znak                          }
    INCHAR    :CHAR;     { RS232   - Precitani znak                        }
    V24BUF    :ARRAY[1..SIZE] OF BYTE; { RS232 - Krozni buffer             }
    INTRCNT   :WORD;     { RS232   - Stevec polnjebja bufferja             }
    READCNT   :WORD;     { RS232   - Stevec praznjebja bufferja            }
    CTRLCH    :CHAR;     { TIPKOVNICA - Kontrolni znak                     }
    RXATTR    :BYTE;     {*text attribut za sprejete podatke               }
    TXATTR    :BYTE;     {*text attribut za oddane podatke                 }
    GRA       :BOOLEAN;  { TRUE ce je graficni mod aktiven                 }
    R:ARRAY[1..10] OF LONGINT;           { MICRO - prenos z mikrokontr.    }
    CHA:ARRAY[1..40] OF CHAR ABSOLUTE R; { MICRO - prenasamo char polja !  }
    RR:ARRAY[1..10] OF REAL;             { Izpisujemo pa v realni obliki   }
    IRE       :INTEGER;  { index izpisanega numericnega polja meritve      }
    ERAS      :BOOLEAN;  {*GRAFIKA - Brisanje zadnjega scana               }
    COBG      :INTEGER;  {*GRAFIKA - Barva ozadja v grafiki                }
    COOS      :INTEGER;  {*GRAFIKA - Barva osciloskopske crte              }
    COGR      :INTEGER;  {*GRAFIKA - Barva osciloskopa mreza               }
    FPR       :BYTE;     {*GRAFIKA - Faktor prikaza                        }
    XXOF      :INTEGER;  {*GRAFIKA - Ofset mreze                           }
    XMAR      :INTEGER;  {*GRAFIKA - Dolzina aktualne slike v pixlih       }
    XMAR1     :INTEGER;  {*GRAFIKA - Dolzina aktualne slike v pixlih za 1  }
    XMAR2     :INTEGER;  {*GRAFIKA - Dolzina aktualne slike v pixlih za 2  }
    DSLP      :INTEGER;  {*GRAFIKA - Dolzina slike v pixlih                }
    XFOFS     :INTEGER;  {*GRAFIKA - Levi zamik ne glede na faktor         }
    XF1OFS    :INTEGER;  {*GRAFIKA - levi zamik za faktor 1                }
    XF2OFS    :INTEGER;  {*GRAFIKA - levi zamik za faktor 2                }
    YFOFS     :INTEGER;  {*GRAFIKA - Spodnji odmik ne glede na faktor      }
    YF1OFS    :INTEGER;  {*GRAFIKA - Spodnji odmik za faktor 1             }
    YF2OFS    :INTEGER;  {*GRAFIKA - Spodnji odmik za faktor 2             }
    XMAX      :INTEGER;  {*GRAFIKA - Maximalna x pozicija za risanje       }
    YMAX      :INTEGER;  {*GRAFIKA - Maximalna y pozicija za risanje       }
    VIEWXMAX  :INTEGER;  {*GRAFIKA - Maximalna x pozicija za pisanje       }
    VIEWYMAX  :INTEGER;  {*GRAFIKA - Maximalna y pozicija za pisanje       }
    PSTEP     :INTEGER;  {*GRAFIKA - Stevilo pixlov za mrezo               }
    Y1        :INTEGER;  { GRAFIKA - Y pozicija pri izrisu crte grafa      }
    Y2        :INTEGER;  { GRAFIKA - Y pozicija pri izrisu crte grafa      }
    I         :INTEGER;  { WRK     - delovni stevec                        }
    II        :INTEGER;  { WRK     - delovni stevec                        }
    APROC     :PROC;     { MAIN    - Trenutna procedura,ki obdeluje podatke}
    SSTR      :STRING;   { MAIN    - String za izbiro aktivnosti           }
    GRAPHDRIVER:INTEGER; { GRAFIKA - Graficni gonilnik                     }
    GRAPHMODE :INTEGER;  { GRAFIKA - Graficni mod                          }
    MAXCOLORS :WORD;     { GRAFIKA - Maximalno stevilo barv                }
    DRIVERNAME:STRING;   { GRAFIKA - Zunanji BGI driver                    }
    DRIVERMODE:INTEGER;  { GRAFIKA - Zunanji BGI driver MODE               }

{***************************** RS232 BLOK *********************************}
FUNCTION V24INST:BOOLEAN;
{--------------------------------------------------------------------------}
{ Poglej ce je RS232 prisoten                                              }
{ $0FF dobimo ce porta ni !                                                }
{--------------------------------------------------------------------------}
CONST HIGHBUS=255;
BEGIN
  V24INST:=(PORT[COMPORT[SER]+LSROFF]<>HIGHBUS);
END;

PROCEDURE SIOCLEAR;
{--------------------------------------------------------------------------}
{ RS232 CLEAR !                                                            }
{ Port se resetira in parametri se ponovno vpisejo                         }
{--------------------------------------------------------------------------}
CONST RLSINT=06;
      RDAINT=04;
      LSRRDY=$60;
VAR DUMMY:BYTE;
BEGIN
   IF V24INST=FALSE THEN EXIT;     { Ce pota ni koncaj                     }
   WHILE PORT[COMPORT[SER]+LSROFF]<>LSRRDY DO BEGIN
      DUMMY:=PORT[COMPORT[SER]];
   END;
   WHILE PORT[COMPORT[SER]+IIROFF]<>1 DO BEGIN
      IF (PORT[COMPORT[SER]+IIROFF] AND RLSINT)=RLSINT THEN BEGIN
         DUMMY:=PORT[COMPORT[SER]+LSROFF];
         PORT[ICR8259]:=EOIMASK;   { Brisi LINE STATUS-INTERRUPT           }
      END;
      IF (PORT[COMPORT[SER]+IIROFF] AND RDAINT)=RDAINT THEN BEGIN
          DUMMY:=PORT[COMPORT[SER]];
          PORT[ICR8259]:=EOIMASK;
      END;
      IF PORT[COMPORT[SER]+IIROFF]=0 THEN BEGIN
         DUMMY:=PORT[COMPORT[SER]+MSROFF];
         PORT[ICR8259]:=EOIMASK;   { Brisi MODEM-STATUS-INT                }
      END;
   END;
END;

PROCEDURE V24WRITE(CH:CHAR);
{--------------------------------------------------------------------------}
{ Ko procedura ugotovi da lahko odda znak (Prazen TX reg.) odd CH          }
{--------------------------------------------------------------------------}
CONST TXPR=32;           { Bit maska za oznako praznega TX reg.            }
BEGIN
   IF RS232OP THEN BEGIN
      REPEAT
      UNTIL (PORT[COMPORT[SER]+LSROFF] AND TXPR)=TXPR;
      PORT[COMPORT[SER]]:=ORD(CH);
   END;
END;

FUNCTION V24READ:CHAR;
{--------------------------------------------------------------------------}
{ Citanje enega znaka iz interrupt bufferja                                }
{--------------------------------------------------------------------------}
VAR CH:CHAR; { ONLY FOR TEST}
BEGIN
   INLINE($FA);   { CLI - Ugasni interrupte, ko citas z bufferja           }
   IF (BUFIX>0) THEN BEGIN
      V24READ := CHR(V24BUF[READCNT]);
      IF READCNT >= SIZE THEN READCNT:= 1 ELSE INC(READCNT);
      DEC (BUFIX);
   END;
   INLINE($FB);   { STI - Ok, interrupti laufajo !                         }
END;

(*$F+*)
PROCEDURE V24RINGINT;
{--------------------------------------------------------------------------}
{ To je interrupt procedura, ki polni krozni buffer.                       }
{--------------------------------------------------------------------------}
(*$F-*)
INTERRUPT;
BEGIN
   V24BUF[INTRCNT]:=PORT[COMPORT[SER]];
   IF INTRCNT>=SIZE THEN INTRCNT:= 1
                    ELSE INC(INTRCNT);
   INC (BUFIX);
   PORT[EOI8259]:=EOIMASK;
END;

PROCEDURE V24OPEN;
{--------------------------------------------------------------------------}
{ Procedura instalira interrupt rutine in inicializira spremenljivke, ki   }
{ jih te rutine uporabljajo                                                }
{--------------------------------------------------------------------------}
CONST BRDOFLSB=00;      { Naslov odmika za baud rate deljenca - LSB byte   }
      BRDOFMSB=01;      { Naslov odmika za baud rate deljenca - MSB byte   }
      ENDIVMASK=128;    { To ne vem - sem prepisal - mora biti 2^7         }
VAR DIVIS:INTEGER;      { BAUD RATE DIVIDER FACTOR                         }
    LCR:BYTE;           { LINE CONTROL REGISTER                            }
BEGIN
   READCNT:=1;          { Stevec citanja za buffer gredo na 1              }
   INTRCNT:=1;          { Stevec pisanja prav tako !                       }
   BUFIX:=0;            { Index bufferja pa je 0 !                         }
   RS232OP:=TRUE;       { rs323 port je sedaj odprt !                      }
   INLINE ($FA);        { Izkljuci interrupte, ko instaliras nove rutine ! }
   GETINTVEC(COMINT[COMIRQ[SER]],ORGINTVEK);
   SETINTVEC(COMINT[COMIRQ[SER]],@V24RINGINT);
   ORGINTMASK:=PORT[ICR8259];
   PORT[ICR8259]:=ORGINTMASK AND (255-(INTMASK[COMIRQ[SER]]));
   INLINE ($FB);              { Ok interrupti laufajo !                    }
   DIVIS:=ROUND(115200/BAUD); { Izracun baud rate napram maximumu          }
   LCR:=3;                    { Bitcount 8-3                               }
   LCR:=LCR + 0;              { 1 stop bit - 0, 2 stop bita - 4 !          }
   LCR:=LCR + 24;             { Parity 24-EVEN,8-ODD,0-NONE                }
   SIOCLEAR;                  { Vzpostavi in inicializiraj port            }
   PORT[COMPORT[SER]+LCROFF]:=PORT[COMPORT[SER]+LCROFF] OR ENDIVMASK;
   PORT[COMPORT[SER]+BRDOFLSB]:=LO(DIVIS);
   PORT[COMPORT[SER]+BRDOFMSB]:=HI(DIVIS);
   PORT[COMPORT[SER]+LCROFF]:=LCR;
   PORT[COMPORT[SER]+IEROFF]:=01;
   PORT[COMPORT[SER]+MCROFF]:=IRQMASK+DTRMASK+RTSMASK;
END;

PROCEDURE V24CLOSE;
{--------------------------------------------------------------------------}
{ Procedura ponovno instalira stare interrupt rutine in inicializira port  }
{ z starimi parametri                                                      }
{--------------------------------------------------------------------------}
BEGIN
   PORT[COMPORT[SER]+IEROFF]:=0;
   SIOCLEAR;
   INLINE($FA);               { Interrupt OFF !                            }
   PORT[ICR8259]:=ORGINTMASK; { 8259 Reset                                 }
   SETINTVEC(COMINT[COMIRQ[SER]],ORGINTVEK); { Install staro rutino        }
   INLINE($FB);               { Ok interrupt UP                            }
   PORT[COMPORT[SER]+MCROFF]:=0;
   SIOCLEAR;
END;

{***************************** CRT   BLOK *********************************}
PROCEDURE SETVGA;
{--------------------------------------------------------------------------}
{ Postavi VGA v najmanj 80x25 textovni mod in izbere barve crk za oddajo   }
{ in za sprejem znakov                                                     }
{--------------------------------------------------------------------------}
VAR  DOSREG:REGISTERS;
BEGIN
   WITH DOSREG DO BEGIN
      AH:=$0F;                { Precitaj video mod                         }
      INTR($10,DOSREG);
      IF (AL < 2) THEN TEXTMODE(CO80); { 80 ali vec kolon !                }
      IF (AL=2) OR (AL=7) THEN BEGIN   { Monocrom kartica                  }
         RXATTR :=$07;
         TXATTR :=$0F;                 { Povdarjeno                        }
      END
      ELSE BEGIN                       { Barvna karta                      }
         RXATTR :=$0A;                 { Svetlo zeleno na crnem            }
         TXATTR :=$0E;                 { rumeno na crnem                   }
      END;                    { Kasneje dodaj v CFG !!!           *******  }
   END;
END;

PROCEDURE TIPKA;
{--------------------------------------------------------------------------}
{ Citaj tipko na tipkovnici                                                }
{--------------------------------------------------------------------------}
BEGIN
   OUTCHAR:=READKEY;
   IF OUTCHAR=CHR(0) THEN CTRLCH:=READKEY
                     ELSE CTRLCH:=CHR(0);
   IF CTRLCH<>CHR(0) THEN WRITE(ORD(CTRLCH)) ; { Samo za testiranje        }
END;

FUNCTION V24IN :CHAR;
{--------------------------------------------------------------------------}
{ Tu lahko prikljucimo avtomatsko zapisovanje v datoteko !                 }
{--------------------------------------------------------------------------}
VAR CH:CHAR;
BEGIN
   CH:=V24READ;
   V24IN:=CH;
END;

FUNCTION V24DATA :BOOLEAN;
{--------------------------------------------------------------------------}
{ Testiranje prispelih podatkov po RS232                                   }
{--------------------------------------------------------------------------}
BEGIN
   V24DATA:=BUFIX<>0;
END;

PROCEDURE V24OUT(CH:CHAR);
{--------------------------------------------------------------------------}
{ Posiljanje znakov na port - razen CH(10)                                 }
{--------------------------------------------------------------------------}
BEGIN
   IF CH<>CHR(10) THEN V24WRITE(CH);
END;

{***************************** GRAPH  BLOK *********************************}
PROCEDURE DRAW(X1,Y1,X2,Y2,COLOR:INTEGER);
{---------------------------------------------------------------------------}
{ Izris crte                                                                }
{---------------------------------------------------------------------------}
BEGIN
  SETCOLOR(COLOR);
  GRAPH.LINE(X1,Y1,X2,Y2);
END;

FUNCTION CHECKON(S1:STRING;PR:PROC;ADD:BOOLEAN):BOOLEAN;
{---------------------------------------------------------------------------}
{ Funkcija pregleduje vse znake, ki prihajajo preko INCHAR spremenljivke    }
{ in glede na njihovo vsebino prozi razlicne procedure za obdelavo          }
{ naslednjih znakov, ki prihajajo                                           }
{---------------------------------------------------------------------------}
VAR ST:STRING;
BEGIN
   CHECKON:=FALSE;
   IF ADD THEN BEGIN
      SSTR:=SSTR+INCHAR;
      IF LENGTH(SSTR)>10 THEN SSTR:=COPY(SSTR,2,40);
   END;
   ST:=COPY(SSTR,BYTE(SSTR[0])-BYTE(S1[0])+1,BYTE(S1[0]));
   IF S1=ST THEN BEGIN
      APROC:=PR;
      SSTR:='';
      CHECKON:=TRUE;
   END;
END;

PROCEDURE FRAME;
{---------------------------------------------------------------------------}
{ Procedura naredi okvircek - v graficnem modu                              }
{---------------------------------------------------------------------------}
BEGIN
   SETVIEWPORT(0,0,XMAX,YMAX-(TEXTHEIGHT('M')+4)-1,CLIPON);
   SETCOLOR(MAXCOLORS);
   RECTANGLE(0,0,XMAX-1,(YMAX-(TEXTHEIGHT('M')+4)-1)-1);
   SETVIEWPORT(1,1,XMAX-2,(YMAX-(TEXTHEIGHT('M')+4)-1)-2,CLIPON);
END;

PROCEDURE TESTGRAPHERROR(GRAPHERR: INTEGER);
{---------------------------------------------------------------------------}
{ Testiranje in izpis napake pri graficnem modu                             }
{---------------------------------------------------------------------------}
VAR CH:CHAR;
BEGIN
   IF GRAPHERR<>GROK THEN BEGIN
      WRITELN('GRAPHICS ERROR: ',GRAPHERRORMSG(GRAPHERR));
      REPEAT
      UNTIL KEYPRESSED;
      CH:=READKEY;
      HALT(1);
   END;
END;

PROCEDURE WRITEG(X,Y:INTEGER;S:STRING);
VAR I,XX,YY:INTEGER;
BEGIN
   MOVETO(X,Y);
   FOR I:=1 TO LENGTH(S) DO BEGIN
      XX:=GETX;
      YY:=GETY;
      BAR(XX,YY,XX+TEXTHEIGHT('M'),YY+TEXTWIDTH('M'));
      OUTTEXT(S[I]);
   END;
END;

PROCEDURE INIT;
{---------------------------------------------------------------------------}
{ Inicializacija graficnega moda                                            }
{ Oskubljena procedura iz ARTY demo programa, ki je prilozen BP 7.0         }
{---------------------------------------------------------------------------}
VAR ERR,I: INTEGER;
    STARTX,STARTY: INTEGER;
    RESOL:RESOLUTION;
    S: STRING;
    DRIVER,MODE:INTEGER;
FUNCTION TEST:INTEGER;
VAR FOUND:BOOLEAN;
BEGIN
   TEST:=2;
END;

BEGIN
   DRIVER:=INSTALLUSERDRIVER(DRIVERNAME,@TEST);
   RESOL:=HIGHER;
   GRAPHDRIVER:=DETECT;
   DETECTGRAPH(GRAPHDRIVER,GRAPHMODE);
   TESTGRAPHERROR(GRAPHRESULT);
   CASE GRAPHDRIVER OF
      CGA:BEGIN
         GRAPHDRIVER:=CGA;
         GRAPHMODE:=CGAC1;
      END;
      MCGA:BEGIN
         CASE GRAPHMODE OF
            MCGAMED,MCGAHI:GRAPHMODE:=MCGAC1;
         END;
      END;
      EGA:BEGIN
         IF RESOL=LOWER THEN GRAPHMODE:=EGALO
                        ELSE GRAPHMODE:=EGAHI;
      END;
      EGA64:BEGIN
         IF RESOL=LOWER THEN GRAPHMODE:=EGA64LO
                        ELSE GRAPHMODE:=EGA64HI;
      END;
      PC3270:BEGIN
         GRAPHDRIVER:=CGA;
         GRAPHMODE:=CGAC1;
      END;
      ATT400:CASE GRAPHMODE OF
          ATT400C1,ATT400C2,ATT400MED,ATT400HI:BEGIN
             GRAPHMODE:=ATT400C1;
          END;
      END;
   END;
   IF DRIVERNAME<>'' THEN INITGRAPH(DRIVER,DRIVERMODE,' ')
                     ELSE INITGRAPH(GRAPHDRIVER,GRAPHMODE,' ');
   TESTGRAPHERROR(GRAPHRESULT);
   SETTEXTSTYLE(TriplexFont{DEFAULTFONT},HORIZDIR,1);
   SETTEXTJUSTIFY(LEFTTEXT,TOPTEXT);
   SETFILLSTYLE(0,0);
   MAXCOLORS:=GETMAXCOLOR;
   XMAX:=GETMAXX;
   YMAX:=GETMAXY;
   VIEWXMAX:=XMAX-2;
   VIEWYMAX:=(YMAX-(TEXTHEIGHT('M')+4)-1)-2;
   STARTX:=XMAX DIV 2;
   STARTY:=YMAX DIV 2;
   Y1:=STARTY;
   Y2:=STARTY;
END;

{$F+}
PROCEDURE GRPRE;
{---------------------------------------------------------------------------}
{ Procedura izrisuje graf v realnem casu  (640x480) only !!                 }
{---------------------------------------------------------------------------}
VAR CO:BYTE;
    B:BYTE;
BEGIN
   INC(II);
   IF II<XFOFS THEN EXIT;
   IF I>XMAX-2 THEN I:=XMAX-2;
   INC(I);
{   IF I>DSLP THEN EXIT; }
   B:=BYTE(INCHAR);
   Y2:=YFOFS-B*FPR;
   CO:=COBG;
   IF ERAS THEN DRAW(I,YFOFS,I,YFOFS-255*FPR,CO);
   IF (I MOD PSTEP)=XXOF THEN BEGIN
      CO:=COGR;
      DRAW(I,YFOFS,I,YFOFS-255*FPR,CO);
   END;
   DRAW(I-1,Y1,I,Y2,COOS);
   PUTPIXEL(I,YFOFS,COGR);
   PUTPIXEL(I,YFOFS- 50*FPR,COGR);
   PUTPIXEL(I,YFOFS-100*FPR,COGR);
   PUTPIXEL(I,YFOFS-150*FPR,COGR);
   PUTPIXEL(I,YFOFS-200*FPR,COGR);
   Y1:=Y2;
   WRITEG(20,20,FORM('###',XXOF));
END;

PROCEDURE WRMEJA;
BEGIN
   IF NOT GRA THEN EXIT;
   RR[10]:=RR[6]-RR[5];        { Velikost obmocja                           }
   RR[9]:=RR[10]/10;           { Obmocje razdelim na 10 delov !             }
   IF (RR[9]>  0.10) AND (RR[9]<=  0.25) THEN RR[9]:=  0.25;
   IF (RR[9]>  0.25) AND (RR[9]<=  0.50) THEN RR[9]:=  0.50;
   IF (RR[9]>  0.50) AND (RR[9]<=  1.00) THEN RR[9]:=  1.00;
   IF (RR[9]>  1.00) AND (RR[9]<=  2.50) THEN RR[9]:=  2.50;
   IF (RR[9]>  2.00) AND (RR[9]<=  5.00) THEN RR[9]:=  5.00;
   IF (RR[9]>  5.00) AND (RR[9]<= 10.00) THEN RR[9]:= 10.00;
   IF (RR[9]> 10.00) AND (RR[9]<= 25.00) THEN RR[9]:= 25.00;
   IF (RR[9]> 25.00) AND (RR[9]<= 50.00) THEN RR[9]:= 50.00;
   IF (RR[9]> 50.00) AND (RR[9]<=100.00) THEN RR[9]:=100.00;
   IF (RR[9]>100.00) AND (RR[9]<=250.00) THEN RR[9]:=250.00;
   IF (RR[9]>250.00) AND (RR[9]<=500.00) THEN RR[9]:=500.00;
   RR[8]:=(TRUNC(RR[5]/RR[9])+1)*RR[9];  { Prva crta v Mhz                  }
   RR[7]:=XMAR/RR[10];         { Stevilo pixlov za Mhz                      }
   XXOF:=TRUNC((RR[8]-RR[5])*RR[7]);{ Odmik za prvo crto v pixlih           }
   PSTEP:=TRUNC(RR[9]*RR[7]);       { Razdalja med crtami                   }



{   RR[7]:=RR[5];
   WHILE RR[7]>RR[9] DO RR[7]:=RR[7]-RR[9];
   DSLP:=(XMAR-XXOF) DIV PSTEP -1;
   DSLP:=PSTEP+DSLP*PSTEP;  }
   WRITEG(10,10,'Meje:'+FORM('######;#',RR[5])+'-'+FORM('######;#',RR[6])+
          ' STEP PIXEL'+FORM('#####',PSTEP)+' MAXPIXEL:'+FORM('#####',XMAR));
   WRITEG(10,40,'Razdelek:'+FORM('####;#',RR[9])+' RR[8]='+FORM('####;####',RR[8])+
          ' RR[7]='+FORM('####;####',RR[7]));
END;

PROCEDURE WRCH;
{---------------------------------------------------------------------------}
{ Izpis znaka na ekran                                                      }
{---------------------------------------------------------------------------}
BEGIN
   IF INCHAR=OUTCHAR THEN BEGIN
      TEXTATTR:=TXATTR;
      WRITE (INCHAR);
      TEXTATTR:=RXATTR;
   END
   ELSE WRITE(INCHAR);
END;

PROCEDURE WRRE;
{---------------------------------------------------------------------------}
{ Prenos znaka v string                                                      }
{---------------------------------------------------------------------------}
BEGIN
   IF INCHAR=OUTCHAR THEN BEGIN
      TEXTATTR:=TXATTR;
      WRITE (INCHAR);
      TEXTATTR:=RXATTR;
   END
   ELSE BEGIN
      INC(IRE);
      IF IRE>40 THEN IRE:=40;
      CHA[IRE]:=INCHAR;
   END;
END;
{$F-}

PROCEDURE MAININIT;
VAR TXT:TEXT;
    IS:STRING;
BEGIN
   XXOF:=0;             { Ofset mreze                                       }
   DRIVERNAME:='';      { Zunanji BGI driver                                }
   ERAS:=TRUE;          { Brisi prejsnjo sliko grafa                        }
   GRA:=FALSE;          { Start ni v graficnem modu                         }
   SER:=2;              { Serijski port je 2                                }
   BAUD:=57600;         { Baudrate je 57600                                 }
   COBG:=03;            { GRAFIKA - Barva ozadja v grafiki                  }
   COOS:=15;            { GRAFIKA - Barva osciloskopske crte                }
   COGR:=05;            { GRAFIKA - Barva osciloskopa mreza                 }
   FPR:=01;             { GRAFIKA - Faktor prikaza                          }
   XFOFS:=1;            { lEVI ZAMIK                                        }
   XF1OFS:=20;          { GRAFIKA - levi zamik za faktor 1                  }
   XF2OFS:=38;          { GRAFIKA - levi zamik za faktor 2                  }
   YF1OFS:=350;         { GRAFIKA - spodnji odmik za faktor 1               }
   YF2OFS:=600;         { GRAFIKA - spodnji odmik za faktor 2               }
   RXATTR:=$71;         { text attribut za sprejete podatke                 }
   TXATTR:=$55;         { text attribut za oddane podatke                   }
   SETVGA;              { Postavi parametre za graficno kartico             }
   TEXTATTR:=RXATTR;    { Privzeta barva je barva sprejetih znakov          }
   IF EXIST('SPAN.CFG') THEN BEGIN
      ASSIGN(TXT,'SPAN.CFG');
      RESET(TXT);
      WHILE NOT EOF(TXT) DO BEGIN
         READLN(TXT,IS);
         IF COPY(IS,1,6)='ERASE=' THEN ERAS:=COPY(IS,7,2)='ON';
         IF COPY(IS,1,4)='COM=' THEN SER:=BYTE(IS[5])-48;
         IF COPY(IS,1,7)='FAKTOR=' THEN FPR:=BYTE(IS[8])-48;
         IF COPY(IS,1,6)='XOFS1=' THEN VAL(COPY(IS,7,2),XF1OFS,I);
         IF COPY(IS,1,6)='XOFS2=' THEN VAL(COPY(IS,7,2),XF2OFS,I);
         IF COPY(IS,1,6)='YOFS1=' THEN VAL(COPY(IS,7,4),YF1OFS,I);
         IF COPY(IS,1,6)='YOFS2=' THEN VAL(COPY(IS,7,4),YF2OFS,I);
         IF COPY(IS,1,6)='XMAR1=' THEN VAL(COPY(IS,7,4),XMAR1,I);
         IF COPY(IS,1,6)='XMAR2=' THEN VAL(COPY(IS,7,4),XMAR2,I);
         IF COPY(IS,1,7)='DRIVER=' THEN DRIVERNAME:=TRUNCSTR(COPY(IS,8,8));
         IF COPY(IS,1,7)='DRMODE=' THEN DRIVERMODE:=BYTE(IS[8])-48;
      END;
      CLOSE(TXT);
   END;
END;

{***************************** MAIN   BLOK *********************************}
BEGIN
   MAININIT;
   CLRSCR;
   IF V24INST=FALSE THEN BEGIN
      CLRSCR;
      WRITELN(' NAPAKA - COM PORTA'++CHR(48+SER)+' NI !');
      HALT(0);
   END
   ELSE V24OPEN;
   CTRLCH:=CHR(0);
   OUTCHAR:=CHR(0);
   APROC:=WRCH;
   REPEAT               { Glavna zanka                                      }
      IF KEYPRESSED THEN BEGIN
         TIPKA;
         CASE CTRLCH OF
            CHR(18):BEGIN                          {ALT-E}
               IF NOT((RR[1]>1800) AND (RR[1]<4000)) THEN BEGIN
                  OUTCHAR:='S';
                  V24OUT(OUTCHAR);
                  OUTCHAR:=#13;
                  V24OUT(OUTCHAR);
                  DELAY(500);
               END
               ELSE BEGIN
                  OUTCHAR:='W';
                  V24OUT(OUTCHAR);
                  OUTCHAR:=' ';
                  V24OUT(OUTCHAR);
                  IF FPR=1 THEN BEGIN
                     OUTCHAR:=CHAR(47);
                     XFOFS:=XF1OFS;
                     YFOFS:=YF1OFS;
                  END;
                  IF FPR>=2 THEN BEGIN
                     OUTCHAR:=CHAR(27);
                     XFOFS:=XF2OFS;
                     YFOFS:=YF2OFS;
                  END;
                  V24OUT(OUTCHAR);
                  OUTCHAR:=#13;
                  V24OUT(OUTCHAR);
                  DELAY(100);
                  OUTCHAR:='E';
                  V24OUT(OUTCHAR);
                  OUTCHAR:=#13;
                  V24OUT(OUTCHAR);
               END;
            END;
            CHR(20):ERAS:=NOT ERAS;
            CHR(77):BEGIN
               INC(XXOF);
               IF XXOF>PSTEP THEN XXOF:=50;
            END;
            CHR(75):BEGIN
               DEC(XXOF);
               IF XXOF<0  THEN XXOF:=0;
            END;
            CHR(72):BEGIN
               PSTEP:=PSTEP*2;
            END;
            CHR(80):BEGIN
               PSTEP:=PSTEP DIV 2
            END;
            ELSE IF CTRLCH<>CHR(45) THEN V24OUT(OUTCHAR);
         END;
      END;
      IF V24DATA THEN BEGIN
         INCHAR:=V24IN;
         APROC;
         IF CHECKON('Prenos E',GRPRE,TRUE) THEN BEGIN
            IF NOT GRA THEN BEGIN
               INIT;
               GRA:=TRUE;
               FRAME;
               WRMEJA;
            END;
            I:=0;
            Y1:=0;
         END;
         IF CHECKON('Vrstica',GRPRE,FALSE) THEN BEGIN
            IF NOT GRA THEN BEGIN
               INIT;
               GRA:=TRUE;
               FRAME;
               WRMEJA;
            END;
            I:=0;
            II:=0;
            Y1:=0;
         END;
         IF CHECKON('Rep',GRPRE,FALSE) THEN BEGIN
            DELAY(10);
            INCHAR:='E';
            V24OUT(INCHAR);
            INCHAR:=#13;
            V24OUT(INCHAR);
            DELAY(10);
         END;
         IF CHECKON('End',WRCH,FALSE) THEN BEGIN
            CLOSEGRAPH;
            RESTORECRTMODE;
            WRITELN('OK !',I:5);
         END;
         IF CHECKON('Rez',WRRE,FALSE) THEN BEGIN
            IRE:=0;
         END;
         IF CHECKON('Preklop',WRCH,FALSE) THEN BEGIN
            WRITELN;
            FOR I:=1 TO 6 DO BEGIN
               RR[I]:=R[I];
               RR[I]:=RR[I]/2560;
               WRITELN(RR[I]:8:2);
            END;
            IF FPR=1 THEN BEGIN
               XMAR:=XMAR1;
            END;
            IF FPR>=2 THEN BEGIN
               XMAR:=XMAR2;
            END;
         END;
      END;
   UNTIL CTRLCH=CHR(45);                                       {ALT-X}
   V24CLOSE;
   WINDOW(1,1,80,25);
   TEXTATTR:=07;
   CLRSCR;
END.
